/*
***********************************************************************************************
**        O.S   : FreeBSD
**   FILE NAME  : arcmsr.h
**        BY    : Erich Chen   
**   Description: SCSI RAID Device Driver for 
**                ARECA SATA RAID HOST Adapter
**                [RAID controller:INTEL 331(PCI-X) 341(PCI-EXPRESS) chip set]
***********************************************************************************************
************************************************************************
** Copyright (C) 2002 - 2005, Areca Technology Corporation All rights reserved.
**
**     Web site: www.areca.com.tw
**       E-mail: erich@areca.com.tw
**
** Redistribution and use in source and binary forms,with or without
** modification,are permitted provided that the following conditions
** are met:
** 1. Redistributions of source code must retain the above copyright
**    notice,this list of conditions and the following disclaimer.
** 2. Redistributions in binary form must reproduce the above copyright
**    notice,this list of conditions and the following disclaimer in the
**    documentation and/or other materials provided with the distribution.
** 3. The name of the author may not be used to endorse or promote products
**    derived from this software without specific prior written permission.
**
** THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
** IMPLIED WARRANTIES,INCLUDING,BUT NOT LIMITED TO,THE IMPLIED WARRANTIES
** OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
** IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,INDIRECT,
** INCIDENTAL,SPECIAL,EXEMPLARY,OR CONSEQUENTIAL DAMAGES(INCLUDING,BUT
** NOT LIMITED TO,PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA,OR PROFITS; OR BUSINESS INTERRUPTION)HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY,WHETHER IN CONTRACT,STRICT LIABILITY,OR TORT
**(INCLUDING NEGLIGENCE OR OTHERWISE)ARISING IN ANY WAY OUT OF THE USE OF
** THIS SOFTWARE,EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**************************************************************************
* $FreeBSD: src/sys/dev/arcmsr/arcmsr.h,v 1.4 2007/03/06 01:12:15 scottl Exp $
*/
#define ARCMSR_DRIVER_VERSION                        "Driver Version 1.20.00.14 2007-2-05"
#define ARCMSR_SCSI_INITIATOR_ID                                              255
#define ARCMSR_DEV_SECTOR_SIZE                                                512
#define ARCMSR_MAX_XFER_SECTORS                                              4096
#define ARCMSR_MAX_TARGETID                                                    16 /*16 max target id + 1*/
#define ARCMSR_MAX_TARGETLUN                                                    8 /*8*/
#define ARCMSR_MAX_CHIPTYPE_NUM                                                 4
#define ARCMSR_MAX_OUTSTANDING_CMD                                            256
#define ARCMSR_MAX_START_JOB                                                  257
#define ARCMSR_MAX_CMD_PERLUN                          ARCMSR_MAX_OUTSTANDING_CMD
#define ARCMSR_MAX_FREESRB_NUM                                                320
#define ARCMSR_MAX_QBUFFER                                                   4096 /* ioctl QBUFFER */
#define ARCMSR_MAX_SG_ENTRIES                                                  38 /* max 38*/
#define ARCMSR_MAX_ADAPTER                                                      4
#define ARCMSR_RELEASE_SIMQ_LEVEL                                             230
/*
*********************************************************************
*/
#ifndef TRUE
    #define TRUE  1
#endif
#ifndef FALSE
    #define FALSE 0
#endif
#ifndef INTR_ENTROPY
    # define INTR_ENTROPY 0
#endif

#ifndef offsetof
	#define offsetof(type, member)  ((size_t)(&((type *)0)->member))
#endif
/*
**********************************************************************************
**
**********************************************************************************
*/
#define PCI_VENDOR_ID_ARECA                                                0x17D3 /* Vendor ID	*/
#define PCI_DEVICE_ID_ARECA_1110                                           0x1110 /* Device ID	*/
#define PCI_DEVICE_ID_ARECA_1120                                           0x1120 /* Device ID	*/
#define PCI_DEVICE_ID_ARECA_1130                                           0x1130 /* Device ID	*/
#define PCI_DEVICE_ID_ARECA_1160                                           0x1160 /* Device ID	*/
#define PCI_DEVICE_ID_ARECA_1170                                           0x1170 /* Device ID	*/
#define PCI_DEVICE_ID_ARECA_1210                                           0x1210 /* Device ID	*/
#define PCI_DEVICE_ID_ARECA_1220                                           0x1220 /* Device ID	*/
#define PCI_DEVICE_ID_ARECA_1230                                           0x1230 /* Device ID	*/
#define PCI_DEVICE_ID_ARECA_1260                                           0x1260 /* Device ID	*/
#define PCI_DEVICE_ID_ARECA_1270                                           0x1270 /* Device ID	*/
#define PCI_DEVICE_ID_ARECA_1280                                           0x1280 /* Device ID	*/
#define PCI_DEVICE_ID_ARECA_1380                                           0x1380 /* Device ID	*/
#define PCI_DEVICE_ID_ARECA_1381                                           0x1381 /* Device ID	*/
#define PCI_DEVICE_ID_ARECA_1680                                           0x1680 /* Device ID	*/
#define PCI_DEVICE_ID_ARECA_1681                                           0x1681 /* Device ID	*/

#define PCIDevVenIDARC1110                                           0x111017D3 /* Vendor Device ID	*/
#define PCIDevVenIDARC1120                                           0x112017D3 /* Vendor Device ID	*/
#define PCIDevVenIDARC1130                                           0x113017D3 /* Vendor Device ID	*/
#define PCIDevVenIDARC1160                                           0x116017D3 /* Vendor Device ID	*/
#define PCIDevVenIDARC1170                                           0x117017D3 /* Vendor Device ID	*/
#define PCIDevVenIDARC1210                                           0x121017D3 /* Vendor Device ID	*/
#define PCIDevVenIDARC1220                                           0x122017D3 /* Vendor Device ID	*/
#define PCIDevVenIDARC1230                                           0x123017D3 /* Vendor Device ID	*/
#define PCIDevVenIDARC1260                                           0x126017D3 /* Vendor Device ID	*/
#define PCIDevVenIDARC1270                                           0x127017D3 /* Vendor Device ID	*/
#define PCIDevVenIDARC1280                                           0x128017D3 /* Vendor Device ID	*/
#define PCIDevVenIDARC1380                                           0x138017D3 /* Vendor Device ID	*/
#define PCIDevVenIDARC1381                                           0x138117D3 /* Vendor Device ID	*/
#define PCIDevVenIDARC1680                                           0x168017D3 /* Vendor Device ID	*/
#define PCIDevVenIDARC1681                                           0x168117D3 /* Vendor Device ID	*/

#ifndef PCIR_BARS
	#define PCIR_BARS	0x10
	#define	PCIR_BAR(x)	(PCIR_BARS + (x) * 4)
#endif

#define PCI_BASE_ADDR0                                               0x10
#define PCI_BASE_ADDR1                                               0x14
#define PCI_BASE_ADDR2                                               0x18
#define PCI_BASE_ADDR3                                               0x1C
#define PCI_BASE_ADDR4                                               0x20
#define PCI_BASE_ADDR5                                               0x24
/*
**********************************************************************************
**
**********************************************************************************
*/
#define ARCMSR_SCSICMD_IOCTL                                         0x77
#define ARCMSR_CDEVSW_IOCTL                                          0x88
#define ARCMSR_MESSAGE_FAIL                                          0x0001
#define	ARCMSR_MESSAGE_SUCCESS                                       0x0000
/*
**********************************************************************************
**
**********************************************************************************
*/
#define arcmsr_ccbsrb_ptr                  							spriv_ptr0
#define arcmsr_ccbacb_ptr                  							spriv_ptr1
#define dma_addr_hi32(addr)                							(u_int32_t) ((addr>>16)>>16)
#define dma_addr_lo32(addr)                							(u_int32_t) (addr & 0xffffffff)
#define get_min(x,y)            ((x) < (y) ? (x) : (y))
#define get_max(x,y)            ((x) < (y) ? (y) : (x))
/*
**********************************************************************************
**
**********************************************************************************
*/
#define ARCMSR_IOP_ERROR_ILLEGALPCI            	0x0001
#define ARCMSR_IOP_ERROR_VENDORID              	0x0002
#define ARCMSR_IOP_ERROR_DEVICEID              	0x0002
#define ARCMSR_IOP_ERROR_ILLEGALCDB           	0x0003
#define ARCMSR_IOP_ERROR_UNKNOW_CDBERR        	0x0004
#define ARCMSR_SYS_ERROR_MEMORY_ALLOCATE    	0x0005
#define ARCMSR_SYS_ERROR_MEMORY_CROSS4G     	0x0006
#define ARCMSR_SYS_ERROR_MEMORY_LACK        	0x0007
#define ARCMSR_SYS_ERROR_MEMORY_RANGE           0x0008
#define ARCMSR_SYS_ERROR_DEVICE_BASE            0x0009
#define ARCMSR_SYS_ERROR_PORT_VALIDATE          0x000A
/*DeviceType*/
#define ARECA_SATA_RAID                      	0x90000000
/*FunctionCode*/
#define FUNCTION_READ_RQBUFFER               	0x0801
#define FUNCTION_WRITE_WQBUFFER              	0x0802
#define FUNCTION_CLEAR_RQBUFFER              	0x0803
#define FUNCTION_CLEAR_WQBUFFER              	0x0804
#define FUNCTION_CLEAR_ALLQBUFFER            	0x0805
#define FUNCTION_REQUEST_RETURNCODE_3F         	0x0806
#define FUNCTION_SAY_HELLO                   	0x0807
#define FUNCTION_SAY_GOODBYE                    0x0808
#define FUNCTION_FLUSH_ADAPTER_CACHE           	0x0809
/*
************************************************************************
**        IOCTL CONTROL CODE
************************************************************************
*/
struct CMD_MESSAGE {
      u_int32_t HeaderLength;
      u_int8_t Signature[8];
      u_int32_t Timeout;
      u_int32_t ControlCode;
      u_int32_t ReturnCode;
      u_int32_t Length;
};

struct CMD_MESSAGE_FIELD {
    struct CMD_MESSAGE cmdmessage; /* ioctl header */
    u_int8_t           messagedatabuffer[1032]; /* areca gui program does not accept more than 1031 byte */
};
/* ARECA IO CONTROL CODE*/
#define ARCMSR_MESSAGE_READ_RQBUFFER           	_IOWR('F', FUNCTION_READ_RQBUFFER, struct CMD_MESSAGE_FIELD)
#define ARCMSR_MESSAGE_WRITE_WQBUFFER          	_IOWR('F', FUNCTION_WRITE_WQBUFFER, struct CMD_MESSAGE_FIELD)
#define ARCMSR_MESSAGE_CLEAR_RQBUFFER          	_IOWR('F', FUNCTION_CLEAR_RQBUFFER, struct CMD_MESSAGE_FIELD)
#define ARCMSR_MESSAGE_CLEAR_WQBUFFER          	_IOWR('F', FUNCTION_CLEAR_WQBUFFER, struct CMD_MESSAGE_FIELD)
#define ARCMSR_MESSAGE_CLEAR_ALLQBUFFER        	_IOWR('F', FUNCTION_CLEAR_ALLQBUFFER, struct CMD_MESSAGE_FIELD)
#define ARCMSR_MESSAGE_REQUEST_RETURNCODE_3F   	_IOWR('F', FUNCTION_REQUEST_RETURNCODE_3F, struct CMD_MESSAGE_FIELD)
#define ARCMSR_MESSAGE_SAY_HELLO               	_IOWR('F', FUNCTION_SAY_HELLO, struct CMD_MESSAGE_FIELD) 
#define ARCMSR_MESSAGE_SAY_GOODBYE              _IOWR('F', FUNCTION_SAY_GOODBYE, struct CMD_MESSAGE_FIELD)
#define ARCMSR_MESSAGE_FLUSH_ADAPTER_CACHE      _IOWR('F', FUNCTION_FLUSH_ADAPTER_CACHE, struct CMD_MESSAGE_FIELD)
/* ARECA IOCTL ReturnCode */
#define ARCMSR_MESSAGE_RETURNCODE_OK              0x00000001
#define ARCMSR_MESSAGE_RETURNCODE_ERROR           0x00000006
#define ARCMSR_MESSAGE_RETURNCODE_3F              0x0000003F
/* 
*************************************************************
**   structure for holding DMA address data 
*************************************************************
*/
#define IS_SG64_ADDR                0x01000000 /* bit24 */
/*
************************************************************************************************
**                            ARECA FIRMWARE SPEC
************************************************************************************************
**		Usage of IOP331 adapter
**		(All In/Out is in IOP331's view)
**		1. Message 0 --> InitThread message and retrun code
**		2. Doorbell is used for RS-232 emulation
**				inDoorBell :    bit0 -- data in ready            (DRIVER DATA WRITE OK)
**								bit1 -- data out has been read   (DRIVER DATA READ OK)
**				outDooeBell:    bit0 -- data out ready           (IOP331 DATA WRITE OK)
**								bit1 -- data in has been read    (IOP331 DATA READ OK)
**		3. Index Memory Usage
**			offset 0xf00 : for RS232 out (request buffer)
**			offset 0xe00 : for RS232 in  (scratch buffer)
**			offset 0xa00 : for inbound message code message_rwbuffer (driver send to IOP331)
**			offset 0xa00 : for outbound message code message_rwbuffer (IOP331 send to driver)
**		4. RS-232 emulation
**			Currently 128 byte buffer is used
**			          1st u_int32_t : Data length (1--124)
**			        Byte 4--127 : Max 124 bytes of data
**		5. PostQ
**		All SCSI Command must be sent through postQ:
**		(inbound queue port)	Request frame must be 32 bytes aligned 
**            #   bit27--bit31 => flag for post ccb 
**			  #   bit0--bit26 => real address (bit27--bit31) of post arcmsr_cdb  
**													bit31 : 0 : 256 bytes frame
**															1 : 512 bytes frame
**													bit30 : 0 : normal request
**															1 : BIOS request
**                                                  bit29 : reserved
**                                                  bit28 : reserved
**                                                  bit27 : reserved
**  -------------------------------------------------------------------------------
**		(outbount queue port)	Request reply                          
**            #   bit27--bit31 => flag for reply
**			  #   bit0--bit26 => real address (bit27--bit31) of reply arcmsr_cdb 
**													bit31 : must be 0 (for this type of reply)
**													bit30 : reserved for BIOS handshake
**													bit29 : reserved
**													bit28 : 0 : no error, ignore AdapStatus/DevStatus/SenseData
**															1 : Error, error code in AdapStatus/DevStatus/SenseData
**													bit27 : reserved
**		6. BIOS request
**			All BIOS request is the same with request from PostQ
**			Except :
**				Request frame is sent from configuration space
**								offset: 0x78 : Request Frame (bit30 == 1)
**								offset: 0x18 : writeonly to generate IRQ to IOP331
**				Completion of request:
**				                      (bit30 == 0, bit28==err flag)
**		7. Definition of SGL entry (structure)
**		8. Message1 Out - Diag Status Code (????)
**		9. Message0 message code :
**			0x00 : NOP
**			0x01 : Get Config ->offset 0xa00 :for outbound message code message_rwbuffer (IOP331 send to driver)
**												Signature             0x87974060(4)
**												Request len           0x00000200(4)
**												numbers of queue      0x00000100(4)
**												SDRAM Size            0x00000100(4)-->256 MB
**												IDE Channels          0x00000008(4)
**												vendor                40 bytes char
**												model                  8 bytes char
**												FirmVer               16 bytes char
**                          					Device Map            16 bytes char
**
**                          					FirmwareVersion DWORD <== Added for checking of new firmware capability
**			0x02 : Set Config ->offset 0xa00 : for inbound message code message_rwbuffer (driver send to IOP331)
**												Signature             0x87974063(4)
**												UPPER32 of Request Frame  (4)-->Driver Only
**			0x03 : Reset (Abort all queued Command)
**			0x04 : Stop Background Activity
**			0x05 : Flush Cache
**			0x06 : Start Background Activity (re-start if background is halted)
**			0x07 : Check If Host Command Pending (Novell May Need This Function)
**			0x08 : Set controller time ->offset 0xa00 : for inbound message code message_rwbuffer (driver to IOP331)
**			        							byte 0 : 0xaa <-- signature
**                          					byte 1 : 0x55 <-- signature
**			        							byte 2 : year (04)
**			        							byte 3 : month (1..12)
**			        							byte 4 : date (1..31)
**			        							byte 5 : hour (0..23)
**			        							byte 6 : minute (0..59)
**			        							byte 7 : second (0..59)
************************************************************************************************
*/
/* signature of set and get firmware config */
#define ARCMSR_SIGNATURE_GET_CONFIG                   0x87974060
#define ARCMSR_SIGNATURE_SET_CONFIG                   0x87974063
/* message code of inbound message register */
#define ARCMSR_INBOUND_MESG0_NOP                      0x00000000
#define ARCMSR_INBOUND_MESG0_GET_CONFIG               0x00000001
#define ARCMSR_INBOUND_MESG0_SET_CONFIG               0x00000002
#define ARCMSR_INBOUND_MESG0_ABORT_CMD                0x00000003
#define ARCMSR_INBOUND_MESG0_STOP_BGRB                0x00000004
#define ARCMSR_INBOUND_MESG0_FLUSH_CACHE              0x00000005
#define ARCMSR_INBOUND_MESG0_START_BGRB               0x00000006
#define ARCMSR_INBOUND_MESG0_CHK331PENDING            0x00000007
#define ARCMSR_INBOUND_MESG0_SYNC_TIMER               0x00000008
/* doorbell interrupt generator */
#define ARCMSR_INBOUND_DRIVER_DATA_WRITE_OK           0x00000001
#define ARCMSR_INBOUND_DRIVER_DATA_READ_OK            0x00000002
#define ARCMSR_OUTBOUND_IOP331_DATA_WRITE_OK          0x00000001
#define ARCMSR_OUTBOUND_IOP331_DATA_READ_OK           0x00000002
/* srb areca cdb flag */
#define ARCMSR_SRBPOST_FLAG_SGL_BSIZE                 0x80000000
#define ARCMSR_SRBPOST_FLAG_IAM_BIOS                  0x40000000
#define ARCMSR_SRBREPLY_FLAG_IAM_BIOS                 0x40000000
#define ARCMSR_SRBREPLY_FLAG_ERROR                    0x10000000
/* outbound firmware ok */
#define ARCMSR_OUTBOUND_MESG1_FIRMWARE_OK             0x80000000
/*
**********************************
**
**********************************
*/
/* size 8 bytes */
struct SG32ENTRY {                             /* length bit 24 == 0                      */
    u_int32_t						length;    /* high 8 bit == flag,low 24 bit == length */
    u_int32_t						address;
};
/* size 12 bytes */
struct SG64ENTRY {                             /* length bit 24 == 1                      */
  	u_int32_t       				length;    /* high 8 bit == flag,low 24 bit == length */
   	u_int32_t       				address; 
   	u_int32_t       				addresshigh;
};
struct SGENTRY_UNION {
	union {
  		struct SG32ENTRY            sg32entry;   /* 30h   Scatter gather address  */
  		struct SG64ENTRY            sg64entry;   /* 30h                           */
	}u;
};
/*
**********************************
**
**********************************
*/
struct QBUFFER {
	u_int32_t     data_len;
    u_int8_t      data[124];
};
/*
************************************************************************************************
**      FIRMWARE INFO
************************************************************************************************
*/
struct FIRMWARE_INFO {
	u_int32_t      signature;                /*0,00-03*/
	u_int32_t      request_len;              /*1,04-07*/
	u_int32_t      numbers_queue;            /*2,08-11*/
	u_int32_t      sdram_size;               /*3,12-15*/
	u_int32_t      ide_channels;             /*4,16-19*/
	char           vendor[40];               /*5,20-59*/
	char           model[8];                 /*15,60-67*/
	char           firmware_ver[16];         /*17,68-83*/
	char           device_map[16];           /*21,84-99*/
};
/*
************************************************************************************************
**    size 0x1F8 (504)
************************************************************************************************
*/
struct ARCMSR_CDB {
	u_int8_t     						Bus;              /* 00h   should be 0            */
	u_int8_t     						TargetID;         /* 01h   should be 0--15        */
	u_int8_t     						LUN;              /* 02h   should be 0--7         */
	u_int8_t     						Function;         /* 03h   should be 1            */

	u_int8_t     						CdbLength;        /* 04h   not used now           */
	u_int8_t     						sgcount;          /* 05h                          */
	u_int8_t     						Flags;            /* 06h                          */
#define ARCMSR_CDB_FLAG_SGL_BSIZE          0x01   /* bit 0: 0(256) / 1(512) bytes         */
#define ARCMSR_CDB_FLAG_BIOS               0x02   /* bit 1: 0(from driver) / 1(from BIOS) */
#define ARCMSR_CDB_FLAG_WRITE              0x04	  /* bit 2: 0(Data in) / 1(Data out)      */
#define ARCMSR_CDB_FLAG_SIMPLEQ            0x00	  /* bit 4/3 ,00 : simple Q,01 : head of Q,10 : ordered Q */
#define ARCMSR_CDB_FLAG_HEADQ              0x08
#define ARCMSR_CDB_FLAG_ORDEREDQ           0x10
	u_int8_t     						Reserved1;        /* 07h                             */

	u_int32_t    						Context;          /* 08h   Address of this request */
	u_int32_t    						DataLength;       /* 0ch   not used now            */

	u_int8_t     						Cdb[16];          /* 10h   SCSI CDB                */
	/*
	********************************************************
	**Device Status : the same from SCSI bus if error occur 
	** SCSI bus status codes.
	********************************************************
	*/
	u_int8_t     						DeviceStatus;     /* 20h   if error                */
#define SCSISTAT_GOOD                  		0x00
#define SCSISTAT_CHECK_CONDITION       		0x02
#define SCSISTAT_CONDITION_MET         		0x04
#define SCSISTAT_BUSY                  		0x08
#define SCSISTAT_INTERMEDIATE          		0x10
#define SCSISTAT_INTERMEDIATE_COND_MET 		0x14
#define SCSISTAT_RESERVATION_CONFLICT  		0x18
#define SCSISTAT_COMMAND_TERMINATED    		0x22
#define SCSISTAT_QUEUE_FULL            		0x28
#define ARCMSR_DEV_SELECT_TIMEOUT               0xF0
#define ARCMSR_DEV_ABORTED                      0xF1
#define ARCMSR_DEV_INIT_FAIL                    0xF2

	u_int8_t     						SenseData[15];    /* 21h   output                  */        

	union {
  		struct SG32ENTRY                sg32entry[ARCMSR_MAX_SG_ENTRIES];        /* 30h   Scatter gather address  */
  		struct SG64ENTRY                sg64entry[ARCMSR_MAX_SG_ENTRIES];        /* 30h                           */
	} u;
};
/*
*********************************************************************
**                   Command Control Block (SrbExtension)
** SRB must be not cross page boundary,and the order from offset 0
**         structure describing an ATA disk request
**             this SRB length must be 32 bytes boundary
*********************************************************************
*/
struct CommandControlBlock {
	struct ARCMSR_CDB      			arcmsr_cdb;
	/* 0-503 (size of CDB=504): arcmsr messenger scsi command descriptor size 504 bytes */
	u_int32_t					cdb_shifted_phyaddr;     /* 504-507 */
        u_int32_t					reserved1;               /* 508-511*/
	/*  ======================512+32 bytes============================  */
#if defined(__x86_64__) || defined(__amd64__) || defined(__ia64__) || defined(__sparc64__) || defined(__powerpc__)
		union ccb *				pccb;                    /* 512-515 516-519 pointer of freebsd scsi command */
		struct AdapterControlBlock *		acb;                     /* 520-523 524-527 */
		bus_dmamap_t				dm_segs_dmamap;          /* 528-531 532-535 */
		u_int16_t   				srb_flags;               /* 536-537 */
	#define		SRB_FLAG_READ		        0x0000
	#define		SRB_FLAG_WRITE		        0x0001
	#define		SRB_FLAG_ERROR		        0x0002
	#define		SRB_FLAG_FLUSHCACHE	        0x0004
	#define		SRB_FLAG_MASTER_ABORTED         0x0008
		u_int16_t				startdone;                /* 538-539 */
	#define		ARCMSR_SRB_DONE   	        0x0000
	#define		ARCMSR_SRB_START   	        0x55AA
	#define		ARCMSR_SRB_ABORTED	        0xAA55
	#define		ARCMSR_SRB_ILLEGAL	        0xFFFF
	    u_int32_t					reserved2;                /* 540-543 */
#else
		union ccb *				pccb;                     /* 512-515 pointer of freebsd scsi command */
		struct AdapterControlBlock *		acb;                      /* 516-519 */
		bus_dmamap_t				dm_segs_dmamap;           /* 520-523 */
		u_int16_t   				srb_flags;                /* 524-525 */
	#define		SRB_FLAG_READ		        0x0000
	#define		SRB_FLAG_WRITE		        0x0001
	#define		SRB_FLAG_ERROR		        0x0002
	#define		SRB_FLAG_FLUSHCACHE	        0x0004
	#define		SRB_FLAG_MASTER_ABORTED         0x0008
		u_int16_t				startdone;                /* 526-527 */
	#define		ARCMSR_SRB_DONE   	        0x0000
	#define		ARCMSR_SRB_START   	        0x55AA
	#define		ARCMSR_SRB_ABORTED	        0xAA55
	#define		ARCMSR_SRB_ILLEGAL	        0xFFFF
		u_int32_t				reserved2[4];             /* 528-531 532-535 536-539 540-543 */
#endif
    /*  ==========================================================  */
};
/*
*********************************************************************
**                 Adapter Control Block
*********************************************************************
*/
struct AdapterControlBlock {
	bus_space_tag_t					btag;
	bus_space_handle_t				bhandle;
	bus_dma_tag_t					parent_dmat;
	bus_dma_tag_t					dm_segs_dmat;                         /* dmat for buffer I/O */  
	bus_dma_tag_t					srb_dmat;                             /* dmat for freesrb */
	bus_dmamap_t					srb_dmamap;
	device_t					pci_dev;
#if __FreeBSD_version < 503000
	dev_t						ioctl_dev;
#else
	struct cdev *					ioctl_dev;
#endif
	int						pci_unit;

	struct resource *				sys_res_arcmsr;
	struct resource *				irqres;
	void *						ih;                                    /* interrupt handle */

	/* Hooks into the CAM XPT */
	struct						cam_sim *psim;
	struct						cam_path *ppath;
	u_int8_t *					uncacheptr;
	unsigned long					vir2phy_offset;
	/* Offset is used in making arc cdb physical to virtual calculations */
	u_int32_t					outbound_int_enable;

	struct MessageUnit *				pmu;                                   /* message unit ATU inbound base address0 */

	u_int8_t					adapter_index;                         /*  */
	u_int8_t					irq;
	u_int16_t					acb_flags;                             /*  */
#define ACB_F_SCSISTOPADAPTER           0x0001
#define ACB_F_MSG_STOP_BGRB             0x0002                               /* stop RAID background rebuild */
#define ACB_F_MSG_START_BGRB            0x0004                               /* stop RAID background rebuild */
#define ACB_F_IOPDATA_OVERFLOW          0x0008                               /* iop ioctl data rqbuffer overflow */
#define ACB_F_MESSAGE_WQBUFFER_CLEARED  0x0010                               /* ioctl clear wqbuffer */
#define ACB_F_MESSAGE_RQBUFFER_CLEARED  0x0020                               /* ioctl clear rqbuffer */
#define ACB_F_MESSAGE_WQBUFFER_READED   0x0040
#define ACB_F_BUS_RESET                 0x0080
#define ACB_F_IOP_INITED                0x0100                               /* iop init */
#define ACB_F_MAPFREESRB_FAILD		0x0200                               /* arcmsr_map_freesrb faild */
#define ACB_F_CAM_DEV_QFRZN             0x0400

	struct CommandControlBlock *			psrb_pool[ARCMSR_MAX_FREESRB_NUM];     /* serial srb pointer array */
	struct CommandControlBlock *			srbworkingQ[ARCMSR_MAX_FREESRB_NUM];   /* working srb pointer array */
	int32_t						workingsrb_doneindex;                  /* done srb array index */
	int32_t						workingsrb_startindex;                 /* start srb array index  */
	int32_t						srboutstandingcount;

	u_int8_t					rqbuffer[ARCMSR_MAX_QBUFFER];          /* data collection buffer for read from 80331 */
	u_int32_t					rqbuf_firstindex;                      /* first of read buffer  */
	u_int32_t					rqbuf_lastindex;                       /* last of read buffer   */

	u_int8_t					wqbuffer[ARCMSR_MAX_QBUFFER];          /* data collection buffer for write to 80331  */
	u_int32_t					wqbuf_firstindex;                      /* first of write buffer */
	u_int32_t					wqbuf_lastindex;                       /* last of write buffer  */

	arcmsr_lock_t					workingQ_done_lock;
	arcmsr_lock_t					workingQ_start_lock;
	arcmsr_lock_t					qbuffer_lock;

	u_int8_t					devstate[ARCMSR_MAX_TARGETID][ARCMSR_MAX_TARGETLUN]; /* id0 ..... id15,lun0...lun7 */
#define ARECA_RAID_GONE                 0x55
#define ARECA_RAID_GOOD                 0xaa
	u_int32_t					num_resets;
	u_int32_t					num_aborts;
	u_int32_t					firm_request_len;                      /*1,04-07*/
	u_int32_t					firm_numbers_queue;                    /*2,08-11*/
	u_int32_t					firm_sdram_size;                       /*3,12-15*/
	u_int32_t					firm_ide_channels;                     /*4,16-19*/
	char						firm_model[12];	                       /*15,60-67*/
	char						firm_version[20];                      /*17,68-83*/
};/* HW_DEVICE_EXTENSION */
/*
*************************************************************
*************************************************************
*/
struct SENSE_DATA {
    u_int8_t 						ErrorCode:7;
    u_int8_t 						Valid:1;
    u_int8_t 						SegmentNumber;
    u_int8_t 						SenseKey:4;
    u_int8_t 						Reserved:1;
    u_int8_t 						IncorrectLength:1;
    u_int8_t 						EndOfMedia:1;
    u_int8_t 						FileMark:1;
    u_int8_t 						Information[4];
    u_int8_t 						AdditionalSenseLength;
    u_int8_t 						CommandSpecificInformation[4];
    u_int8_t 						AdditionalSenseCode;
    u_int8_t 						AdditionalSenseCodeQualifier;
    u_int8_t 						FieldReplaceableUnitCode;
    u_int8_t 						SenseKeySpecific[3];
};
/* 
**********************************
**  Peripheral Device Type definitions 
**********************************
*/
#define SCSI_DASD		      0x00	   /* Direct-access Device	   */
#define SCSI_SEQACESS		      0x01	   /* Sequential-access device     */
#define SCSI_PRINTER		      0x02	   /* Printer device		   */
#define SCSI_PROCESSOR		      0x03	   /* Processor device		   */
#define SCSI_WRITEONCE		      0x04	   /* Write-once device 	   */
#define SCSI_CDROM		      0x05	   /* CD-ROM device		   */
#define SCSI_SCANNER		      0x06	   /* Scanner device		   */
#define SCSI_OPTICAL		      0x07	   /* Optical memory device	   */
#define SCSI_MEDCHGR		      0x08	   /* Medium changer device	   */
#define SCSI_COMM		      0x09	   /* Communications device	   */
#define SCSI_NODEV		      0x1F	   /* Unknown or no device type    */
/*
************************************************************************************************************
**				         @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
**				                          80331 PCI-to-PCI Bridge
**				                          PCI Configuration Space 
**				
**				         @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
**				                            Programming Interface
**				                          ========================
**				            Configuration Register Address Space Groupings and Ranges
**				         =============================================================
**				                 Register Group                      Configuration  Offset
**				         -------------------------------------------------------------
**				            Standard PCI Configuration                      00-3Fh
**				         -------------------------------------------------------------
**				             Device Specific Registers                      40-A7h
**				         -------------------------------------------------------------
**				                   Reserved                                 A8-CBh
**				         -------------------------------------------------------------
**				              Enhanced Capability List                      CC-FFh
** ==========================================================================================================
**                         Standard PCI [Type 1] Configuration Space Address Map
** **********************************************************************************************************
** |    Byte 3              |         Byte 2         |        Byte 1          |       Byte 0              |   Configu-ration Byte Offset
** ----------------------------------------------------------------------------------------------------------
** |                    Device ID                    |                     Vendor ID                      | 00h
** ----------------------------------------------------------------------------------------------------------
** |                 Primary Status                  |                  Primary Command                   | 04h
** ----------------------------------------------------------------------------------------------------------
** |                   Class Code                                             |        RevID              | 08h
** ----------------------------------------------------------------------------------------------------------
** |        reserved        |      Header Type       |      Primary MLT       |      Primary CLS          | 0Ch
** ----------------------------------------------------------------------------------------------------------
** |                                             Reserved                                                 | 10h
** ----------------------------------------------------------------------------------------------------------
** |                                             Reserved                                                 | 14h
** ----------------------------------------------------------------------------------------------------------
** |     Secondary MLT      | Subordinate Bus Number |  Secondary Bus Number  |     Primary Bus Number    | 18h
** ----------------------------------------------------------------------------------------------------------
** |                 Secondary Status                |       I/O Limit        |        I/O Base           | 1Ch
** ----------------------------------------------------------------------------------------------------------
** |      Non-prefetchable Memory Limit Address      |       Non-prefetchable Memory Base Address         | 20h
** ----------------------------------------------------------------------------------------------------------
** |        Prefetchable Memory Limit Address        |           Prefetchable Memory Base Address         | 24h
** ----------------------------------------------------------------------------------------------------------
** |                          Prefetchable Memory Base Address Upper 32 Bits                              | 28h
** ----------------------------------------------------------------------------------------------------------
** |                          Prefetchable Memory Limit Address Upper 32 Bits                             | 2Ch
** ----------------------------------------------------------------------------------------------------------
** |             I/O Limit Upper 16 Bits             |                 I/O Base Upper 16                  | 30h
** ----------------------------------------------------------------------------------------------------------
** |                                Reserved                                  |   Capabilities Pointer    | 34h
** ----------------------------------------------------------------------------------------------------------
** |                                             Reserved                                                 | 38h
** ----------------------------------------------------------------------------------------------------------
** |                   Bridge Control                |  Primary Interrupt Pin | Primary Interrupt Line    | 3Ch
**=============================================================================================================
*/
/*
**=============================================================================================================
**  0x03-0x00 : 
** Bit       Default             Description
**31:16       0335h            Device ID (DID): Indicates the unique device ID that is assigned to bridge by the PCI SIG.
**                             ID is unique per product speed as indicated.
**15:00       8086h            Vendor ID (VID): 16-bit field which indicates that Intel is the vendor.
**=============================================================================================================
*/
#define     ARCMSR_PCI2PCI_VENDORID_REG		         0x00    /*word*/
#define     ARCMSR_PCI2PCI_DEVICEID_REG		         0x02    /*word*/
/*
**==============================================================================
**  0x05-0x04 : command register 
** Bit       Default 		               Description
**15:11        00h		   		             Reserved
** 10          0		   		           Interrupt Disable: Disables/Enables the generation of Interrupts on the primary bus. 
**                		   		                              The bridge does not support interrupts.
** 09          0		   		                 FB2B Enable: Enables/Disables the generation of fast back to back 
**										transactions on the primary bus. 
**                		   		                              The bridge does not generate fast back to back 
**										transactions on the primary bus.
** 08          0		   		          SERR# Enable (SEE): Enables primary bus SERR# assertions.
**                		   		                              0=The bridge does not assert P_SERR#.
**                		   		                              1=The bridge may assert P_SERR#, subject to other programmable criteria.
** 07          0		   		    Wait Cycle Control (WCC): Always returns 0bzero indicating 
**										that bridge does not perform address or data stepping,
** 06          0		   		 Parity Error Response (PER): Controls bridge response to a detected primary bus parity error.
**                		   		                              0=When a data parity error is detected bridge does not assert S_PERR#. 
**                		   		                                  Also bridge does not assert P_SERR# in response to 
**											a detected address or attribute parity error.
**                		   		                              1=When a data parity error is detected bridge asserts S_PERR#. 
**                		   		                                  The bridge also asserts P_SERR# 
**											(when enabled globally via bit(8) of this register) 
**											in response to a detected address or attribute parity error.
** 05          0		  VGA Palette Snoop Enable (VGA_PSE): Controls bridge response to VGA-compatible palette write transactions. 
**                		                                      VGA palette write transactions are I/O transactions
**										 whose address bits are: P_AD[9:0] equal to 3C6h, 3C8h or 3C9h
**                		                                      P_AD[15:10] are not decoded (i.e. aliases are claimed), 
**										or are fully decoding 
**										(i.e., must be all 0's depending upon the VGA 
**										aliasing bit in the Bridge Control Register, offset 3Eh.
**                		                                      P_AD[31:16] equal to 0000h
**                		                                      0=The bridge ignores VGA palette write transactions, 
**										unless decoded by the standard I/O address range window.
**                		                                      1=The bridge responds to VGA palette write transactions 
**										with medium DEVSEL# timing and forwards them to the secondary bus.
** 04          0   Memory Write and Invalidate Enable (MWIE): The bridge does not promote MW transactions to MWI transactions. 
**                                                            MWI transactions targeting resources on the opposite side of the bridge, 
**										however, are forwarded as MWI transactions.
** 03          0                  Special Cycle Enable (SCE): The bridge ignores special cycle transactions. 
**                                                            This bit is read only and always returns 0 when read
** 02          0                     Bus Master Enable (BME): Enables bridge to initiate memory and I/O transactions on the primary interface.
**                                                            Initiation of configuration transactions is not affected by the state of this bit.
**                                                            0=The bridge does not initiate memory or I/O transactions on the primary interface.
**                                                            1=The bridge is enabled to function as an initiator on the primary interface.
** 01          0                   Memory Space Enable (MSE): Controls target response to memory transactions on the primary interface.
**                                                            0=The bridge target response to memory transactions on the primary interface is disabled.
**                                                            1=The bridge target response to memory transactions on the primary interface is enabled.
** 00          0                     I/O Space Enable (IOSE): Controls target response to I/O transactions on the primary interface.
**                                                            0=The bridge target response to I/O transactions on the primary interface is disabled.
**                                                            1=The bridge target response to I/O transactions on the primary interface is enabled.
**==============================================================================
*/
#define     ARCMSR_PCI2PCI_PRIMARY_COMMAND_REG		 0x04    /*word*/
#define     PCI_DISABLE_INTERRUPT                        0x0400
/*
**==============================================================================
**  0x07-0x06 : status register 
** Bit       Default                       Description
** 15          0                       Detected Parity Error: The bridge sets this bit to a 1b whenever it detects an address, 
**									attribute or data parity error. 
**                                                            This bit is set regardless of the state of the PER bit in the command register.
** 14          0                       Signaled System Error: The bridge sets this bit to a 1b whenever it asserts SERR# on the primary bus.
** 13          0                       Received Master Abort: The bridge sets this bit to a 1b when, 
**									acting as the initiator on the primary bus, 
**									its transaction (with the exception of special cycles) 
**									has been terminated with a Master Abort.
** 12          0                       Received Target Abort: The bridge sets this bit to a 1b when, 
**									acting as the initiator on the primary bus, 
**									its transaction has been terminated with a Target Abort.
** 11          0                       Signaled Target Abort: The bridge sets this bit to a 1b when it, 
**									as the target of a transaction, terminates it with a Target Abort. 
**                                                            In PCI-X mode this bit is also set when it forwards a SCM with a target abort error code.
** 10:09       01                             DEVSEL# Timing: Indicates slowest response to a non-configuration command on the primary interface. 
**                                                            Returns 01b when read, indicating that bridge responds no slower than with medium timing.
** 08          0                    Master Data Parity Error: The bridge sets this bit to a 1b when all of the following conditions are true: 
**									The bridge is the current master on the primary bus
**                                                            S_PERR# is detected asserted or is asserted by bridge
**                                                            The Parity Error Response bit is set in the Command register
** 07          1                   Fast Back to Back Capable: Returns a 1b when read indicating that bridge 
**									is able to respond to fast back to back transactions on its primary interface.
** 06          0                             Reserved
** 05          1                   66 MHz Capable Indication: Returns a 1b when read indicating that bridge primary interface is 66 MHz capable.
**                                                            1 =
** 04          1                    Capabilities List Enable: Returns 1b when read indicating that bridge supports PCI standard enhanced capabilities. 
**                                                            Offset 34h (Capability Pointer register) 
**										provides the offset for the first entry 
**										in the linked list of enhanced capabilities.
** 03          0                            Interrupt Status: Reflects the state of the interrupt in the device/function.
**                                                            The bridge does not support interrupts.
** 02:00       000                           Reserved
**==============================================================================
*/
#define     ARCMSR_PCI2PCI_PRIMARY_STATUS_REG	     0x06    /*word: 06,07 */
#define          ARCMSR_ADAP_66MHZ                   0x20
/*
**==============================================================================
**  0x08 : revision ID 
** Bit       Default                       Description
** 07:00       00000000                  Revision ID (RID): '00h' indicating bridge A-0 stepping.
**==============================================================================
*/
#define     ARCMSR_PCI2PCI_REVISIONID_REG		     0x08    /*byte*/
/*
**==============================================================================
**  0x0b-0x09 : 0180_00 (class code 1,native pci mode ) 
** Bit       Default                       Description
** 23:16       06h                     Base Class Code (BCC): Indicates that this is a bridge device.
** 15:08       04h                      Sub Class Code (SCC): Indicates this is of type PCI-to-PCI bridge.
** 07:00       00h               Programming Interface (PIF): Indicates that this is standard (non-subtractive) PCI-PCI bridge.
**==============================================================================
*/
#define     ARCMSR_PCI2PCI_CLASSCODE_REG	         0x09    /*3bytes*/
/*
**==============================================================================
**  0x0c : cache line size 
** Bit       Default                       Description
** 07:00       00h                     Cache Line Size (CLS): Designates the cache line size in 32-bit dword units.
**                                                            The contents of this register are factored into 
**									internal policy decisions associated with memory read prefetching, 
**									and the promotion of Memory Write transactions to MWI transactions.
**                                                            Valid cache line sizes are 8 and 16 dwords. 
**                                                            When the cache line size is set to an invalid value, 
**									bridge behaves as though the cache line size was set to 00h.
**==============================================================================
*/
#define     ARCMSR_PCI2PCI_PRIMARY_CACHELINESIZE_REG 0x0C    /*byte*/
/*
**==============================================================================
**  0x0d : latency timer (number of pci clock 00-ff ) 
** Bit       Default                       Description
**                                   Primary Latency Timer (PTV):
** 07:00      00h (Conventional PCI)   Conventional PCI Mode: Primary bus Master latency timer. Indicates the number of PCI clock cycles,
**                                                            referenced from the assertion of FRAME# to the expiration of the timer, 
**                                                            when bridge may continue as master of the current transaction. All bits are writable, 
**                                                            resulting in a granularity of 1 PCI clock cycle. 
**                                                            When the timer expires (i.e., equals 00h) 
**									bridge relinquishes the bus after the first data transfer 
**									when its PCI bus grant has been deasserted.
**         or 40h (PCI-X)                         PCI-X Mode: Primary bus Master latency timer. 
**                                                            Indicates the number of PCI clock cycles,
**                                                            referenced from the assertion of FRAME# to the expiration of the timer, 
**                                                            when bridge may continue as master of the current transaction. 
**                                                            All bits are writable, resulting in a granularity of 1 PCI clock cycle. 
**                                                            When the timer expires (i.e., equals 00h) bridge relinquishes the bus at the next ADB. 
**                                                            (Except in the case where MLT expires within 3 data phases 
**								of an ADB.In this case bridge continues on 
**								until it reaches the next ADB before relinquishing the bus.)
**==============================================================================
*/
#define     ARCMSR_PCI2PCI_PRIMARY_LATENCYTIMER_REG	 0x0D    /*byte*/
/*
**==============================================================================
**  0x0e : (header type,single function ) 
** Bit       Default                       Description
** 07           0                Multi-function device (MVD): 80331 is a single-function device.
** 06:00       01h                       Header Type (HTYPE): Defines the layout of addresses 10h through 3Fh in configuration space. 
**                                                            Returns 01h when read indicating 
**								that the register layout conforms to the standard PCI-to-PCI bridge layout.
**==============================================================================
*/
#define     ARCMSR_PCI2PCI_HEADERTYPE_REG	         0x0E    /*byte*/
/*
**==============================================================================
**     0x0f   : 
**==============================================================================
*/
/*
**==============================================================================
**  0x13-0x10 : 
**  PCI CFG Base Address #0 (0x10) 
**==============================================================================
*/
/*
**==============================================================================
**  0x17-0x14 : 
**  PCI CFG Base Address #1 (0x14) 
**==============================================================================
*/
/*
**==============================================================================
**  0x1b-0x18 : 
**  PCI CFG Base Address #2 (0x18) 
**-----------------0x1A,0x19,0x18--Bus Number Register - BNR
** Bit       Default                       Description
** 23:16       00h             Subordinate Bus Number (SBBN): Indicates the highest PCI bus number below this bridge. 
**                                                            Any Type 1 configuration cycle 
**									on the primary bus whose bus number is greater than the secondary bus number,
**                                                            and less than or equal to the subordinate bus number 
**									is forwarded unaltered as a Type 1 configuration cycle on the secondary PCI bus.
** 15:08       00h               Secondary Bus Number (SCBN): Indicates the bus number of PCI to which the secondary interface is connected. 
**                                                            Any Type 1 configuration cycle matching this bus number 
**									is translated to a Type 0 configuration cycle (or a Special Cycle) 
**									before being executed on bridge's secondary PCI bus.
** 07:00       00h                  Primary Bus Number (PBN): Indicates bridge primary bus number. 
**                                                            Any Type 1 configuration cycle on the primary interface 
**									with a bus number that is less than the contents 
**									of this register field does not be claimed by bridge.
**-----------------0x1B--Secondary Latency Timer Register - SLTR
** Bit       Default                       Description
**                             Secondary Latency Timer (STV):
** 07:00       00h (Conventional PCI)  Conventional PCI Mode: Secondary bus Master latency timer. 
**                                                            Indicates the number of PCI clock cycles,
**									referenced from the assertion of FRAME# to the expiration of the timer, 
**                                                            when bridge may continue as master of the current transaction. All bits are writable, 
**                                                            resulting in a granularity of 1 PCI clock cycle.
**                                                            When the timer expires (i.e., equals 00h) 
**								bridge relinquishes the bus after the first data transfer 
**								when its PCI bus grant has been deasserted.
**          or 40h (PCI-X)                        PCI-X Mode: Secondary bus Master latency timer. 
**                                                            Indicates the number of PCI clock cycles,referenced from the assertion of FRAME# 
**								to the expiration of the timer, 
**                                                            when bridge may continue as master of the current transaction. All bits are writable, 
**                                                            resulting in a granularity of 1 PCI clock cycle.
**                                                            When the timer expires (i.e., equals 00h) bridge relinquishes the bus at the next ADB. 
**                                                            (Except in the case where MLT expires within 3 data phases of an ADB. 
**								In this case bridge continues on until it reaches the next ADB 
**								before relinquishing the bus)
**==============================================================================
*/
#define     ARCMSR_PCI2PCI_PRIMARY_BUSNUMBER_REG	         0x18    /*3byte 0x1A,0x19,0x18*/
#define     ARCMSR_PCI2PCI_SECONDARY_BUSNUMBER_REG	         0x19    /*byte*/
#define     ARCMSR_PCI2PCI_SUBORDINATE_BUSNUMBER_REG             0x1A    /*byte*/
#define     ARCMSR_PCI2PCI_SECONDARY_LATENCYTIMER_REG	         0x1B    /*byte*/
/*
**==============================================================================
**  0x1f-0x1c : 
**  PCI CFG Base Address #3 (0x1C) 
**-----------------0x1D,0x1C--I/O Base and Limit Register - IOBL
** Bit       Default                       Description
** 15:12        0h            I/O Limit Address Bits [15:12]: Defines the top address of an address range to 
**								determine when to forward I/O transactions from one interface to the other. 
**                                                            These bits correspond to address lines 15:12 for 4KB alignment. 
**                                                            Bits 11:0 are assumed to be FFFh.
** 11:08        1h           I/O Limit Addressing Capability: This field is hard-wired to 1h, indicating support 32-bit I/O addressing.
** 07:04        0h             I/O Base Address Bits [15:12]: Defines the bottom address of 
**								an address range to determine when to forward I/O transactions 
**								from one interface to the other. 
**                                                            These bits correspond to address lines 15:12 for 4KB alignment. 
**								Bits 11:0 are assumed to be 000h.
** 03:00        1h            I/O Base Addressing Capability: This is hard-wired to 1h, indicating support for 32-bit I/O addressing.
**-----------------0x1F,0x1E--Secondary Status Register - SSR
** Bit       Default                       Description
** 15           0b                     Detected Parity Error: The bridge sets this bit to a 1b whenever it detects an address, 
**								attribute or data parity error on its secondary interface.
** 14           0b                     Received System Error: The bridge sets this bit when it samples SERR# asserted on its secondary bus interface.
** 13           0b                     Received Master Abort: The bridge sets this bit to a 1b when, 
**								acting as the initiator on the secondary bus, 
**								it's transaction (with the exception of special cycles) 
**								has been terminated with a Master Abort.
** 12           0b                     Received Target Abort: The bridge sets this bit to a 1b when, 
**								acting as the initiator on the secondary bus, 
**								it's transaction has been terminated with a Target Abort.
** 11           0b                     Signaled Target Abort: The bridge sets this bit to a 1b when it, 
**								as the target of a transaction, terminates it with a Target Abort. 
**                                                            In PCI-X mode this bit is also set when it forwards a SCM with a target abort error code.
** 10:09       01b                            DEVSEL# Timing: Indicates slowest response to a non-configuration command on the secondary interface. 
**                                                            Returns 01b when read, indicating that bridge responds no slower than with medium timing.
** 08           0b                  Master Data Parity Error: The bridge sets this bit to a 1b when all of the following conditions are true:
**                                                            The bridge is the current master on the secondary bus
**                                                            S_PERR# is detected asserted or is asserted by bridge
**                                                            The Parity Error Response bit is set in the Command register 
** 07           1b           Fast Back-to-Back Capable (FBC): Indicates that the secondary interface of bridge can receive fast back-to-back cycles.
** 06           0b                           Reserved
** 05           1b                      66 MHz Capable (C66): Indicates the secondary interface of the bridge is 66 MHz capable.
**                                                            1 =
** 04:00       00h                           Reserved
**==============================================================================
*/
#define     ARCMSR_PCI2PCI_IO_BASE_REG	                     0x1C    /*byte*/
#define     ARCMSR_PCI2PCI_IO_LIMIT_REG	                     0x1D    /*byte*/
#define     ARCMSR_PCI2PCI_SECONDARY_STATUS_REG	             0x1E    /*word: 0x1F,0x1E */
/*
**==============================================================================
**  0x23-0x20 : 
**  PCI CFG Base Address #4 (0x20)
**-----------------0x23,0x22,0x21,0x20--Memory Base and Limit Register - MBL
** Bit       Default                       Description
** 31:20      000h                              Memory Limit: These 12 bits are compared with P_AD[31:20] of the incoming address to determine
**                                                            the upper 1MB aligned value (exclusive) of the range. 
**                                                            The incoming address must be less than or equal to this value. 
**                                                            For the purposes of address decoding the lower 20 address bits (P_AD[19:0] 
**									are assumed to be F FFFFh.
** 19:16        0h                            Reserved.
** 15:04      000h                               Memory Base: These 12 bits are compared with bits P_AD[31:20] 
**								of the incoming address to determine the lower 1MB 
**								aligned value (inclusive) of the range. 
**                                                            The incoming address must be greater than or equal to this value.
**                                                            For the purposes of address decoding the lower 20 address bits (P_AD[19:0]) 
**								are assumed to be 0 0000h.
** 03:00        0h                            Reserved.
**==============================================================================
*/
#define     ARCMSR_PCI2PCI_NONPREFETCHABLE_MEMORY_BASE_REG   0x20    /*word: 0x21,0x20 */
#define     ARCMSR_PCI2PCI_NONPREFETCHABLE_MEMORY_LIMIT_REG  0x22    /*word: 0x23,0x22 */
/*
**==============================================================================
**  0x27-0x24 : 
**  PCI CFG Base Address #5 (0x24) 
**-----------------0x27,0x26,0x25,0x24--Prefetchable Memory Base and Limit Register - PMBL
** Bit       Default                       Description
** 31:20      000h                 Prefetchable Memory Limit: These 12 bits are compared with P_AD[31:20] of the incoming address to determine
**                                                            the upper 1MB aligned value (exclusive) of the range. 
**                                                            The incoming address must be less than or equal to this value. 
**                                                            For the purposes of address decoding the lower 20 address bits (P_AD[19:0] 
**									are assumed to be F FFFFh.
** 19:16        1h                          64-bit Indicator: Indicates that 64-bit addressing is supported.
** 15:04      000h                  Prefetchable Memory Base: These 12 bits are compared with bits P_AD[31:20] 
**								of the incoming address to determine the lower 1MB aligned value (inclusive) 
**								of the range. 
**                                                            The incoming address must be greater than or equal to this value. 
**                                                            For the purposes of address decoding the lower 20 address bits (P_AD[19:0])
**								 are assumed to be 0 0000h.
** 03:00        1h                          64-bit Indicator: Indicates that 64-bit addressing is supported.
**==============================================================================
*/
#define     ARCMSR_PCI2PCI_PREFETCHABLE_MEMORY_BASE_REG      0x24    /*word: 0x25,0x24 */
#define     ARCMSR_PCI2PCI_PREFETCHABLE_MEMORY_LIMIT_REG     0x26    /*word: 0x27,0x26 */
/*
**==============================================================================
**  0x2b-0x28 : 
** Bit       Default                       Description
** 31:00    00000000h Prefetchable Memory Base Upper Portion: All bits are read/writable  
**                                                            bridge supports full 64-bit addressing.
**==============================================================================
*/
#define     ARCMSR_PCI2PCI_PREFETCHABLE_MEMORY_BASE_UPPER32_REG     0x28    /*dword: 0x2b,0x2a,0x29,0x28 */
/*
**==============================================================================
**  0x2f-0x2c : 
** Bit       Default                       Description
** 31:00    00000000h Prefetchable Memory Limit Upper Portion: All bits are read/writable 
**                                                             bridge supports full 64-bit addressing.
**==============================================================================
*/
#define     ARCMSR_PCI2PCI_PREFETCHABLE_MEMORY_LIMIT_UPPER32_REG    0x2C    /*dword: 0x2f,0x2e,0x2d,0x2c */
/*
**==============================================================================
**  0x33-0x30 : 
** Bit       Default                       Description
** 07:00       DCh                      Capabilities Pointer: Pointer to the first CAP ID entry in the capabilities list is at DCh in PCI configuration
**                                                            space. (Power Management Capability Registers)
**==============================================================================
*/
#define     ARCMSR_PCI2PCI_CAPABILITIES_POINTER_REG	                 0x34    /*byte*/ 
/*
**==============================================================================
**  0x3b-0x35 : reserved
**==============================================================================
*/
/*
**==============================================================================
**  0x3d-0x3c : 
**
** Bit       Default                       Description
** 15:08       00h                       Interrupt Pin (PIN): Bridges do not support the generation of interrupts.
** 07:00       00h                     Interrupt Line (LINE): The bridge does not generate interrupts, so this is reserved as '00h'.
**==============================================================================
*/
#define     ARCMSR_PCI2PCI_PRIMARY_INTERRUPT_LINE_REG                0x3C    /*byte*/ 
#define     ARCMSR_PCI2PCI_PRIMARY_INTERRUPT_PIN_REG                 0x3D    /*byte*/ 
/*
**==============================================================================
**  0x3f-0x3e : 
** Bit       Default                       Description
** 15:12        0h                          Reserved
** 11           0b                Discard Timer SERR# Enable: Controls the generation of SERR# on the primary interface (P_SERR#) in response
**                                                            to a timer discard on either the primary or secondary interface.
**                                                            0b=SERR# is not asserted.
**                                                            1b=SERR# is asserted.
** 10           0b                Discard Timer Status (DTS): This bit is set to a '1b' when either the primary or secondary discard timer expires.
**                                                            The delayed completion is then discarded.
** 09           0b             Secondary Discard Timer (SDT): Sets the maximum number of PCI clock cycles 
**									that bridge waits for an initiator on the secondary bus 
**									to repeat a delayed transaction request. 
**                                                            The counter starts when the delayed transaction completion is ready 
**									to be returned to the initiator. 
**                                                            When the initiator has not repeated the transaction 
**									at least once before the counter expires,bridge 
**										discards the delayed transaction from its queues.
**                                                            0b=The secondary master time-out counter is 2 15 PCI clock cycles.
**                                                            1b=The secondary master time-out counter is 2 10 PCI clock cycles.
** 08           0b               Primary Discard Timer (PDT): Sets the maximum number of PCI clock cycles 
**									that bridge waits for an initiator on the primary bus 
**									to repeat a delayed transaction request. 
**                                                            The counter starts when the delayed transaction completion 
**									is ready to be returned to the initiator. 
**                                                            When the initiator has not repeated the transaction 
**									at least once before the counter expires, 
**									bridge discards the delayed transaction from its queues.
**                                                            0b=The primary master time-out counter is 2 15 PCI clock cycles.
**                                                            1b=The primary master time-out counter is 2 10 PCI clock cycles.
** 07           0b            Fast Back-to-Back Enable (FBE): The bridge does not initiate back to back transactions.
** 06           0b                 Secondary Bus Reset (SBR): 
**                                                            When cleared to 0b: The bridge deasserts S_RST#, 
**									when it had been asserted by writing this bit to a 1b.
**                                                                When set to 1b: The bridge asserts S_RST#.
** 05           0b                   Master Abort Mode (MAM): Dictates bridge behavior on the initiator bus 
**									when a master abort termination occurs in response to 
**										a delayed transaction initiated by bridge on the target bus.
**                                                            0b=The bridge asserts TRDY# in response to a non-locked delayed transaction,
**										and returns FFFF FFFFh when a read.
**                                                            1b=When the transaction had not yet been completed on the initiator bus 
**										(e.g.,delayed reads, or non-posted writes), 
**                                                                 then bridge returns a Target Abort in response to the original requester 
**                                                                 when it returns looking for its delayed completion on the initiator bus. 
**                                                                 When the transaction had completed on the initiator bus (e.g., a PMW), 
**										then bridge asserts P_SERR# (when enabled).
**                                   For PCI-X transactions this bit is an enable for the assertion of P_SERR# due to a master abort 
**								while attempting to deliver a posted memory write on the destination bus.
** 04           0b                   VGA Alias Filter Enable: This bit dictates bridge behavior in conjunction with the VGA enable bit 
**								(also of this register), 
**                                                            and the VGA Palette Snoop Enable bit (Command Register). 
**                                                            When the VGA enable, or VGA Palette Snoop enable bits are on (i.e., 1b) 
**									the VGA Aliasing bit for the corresponding enabled functionality,:
**                                                            0b=Ignores address bits AD[15:10] when decoding VGA I/O addresses.
**                                                            1b=Ensures that address bits AD[15:10] equal 000000b when decoding VGA I/O addresses.
**                                   When all VGA cycle forwarding is disabled, (i.e., VGA Enable bit =0b and VGA Palette Snoop bit =0b), 
**									then this bit has no impact on bridge behavior.
** 03           0b                                VGA Enable: Setting this bit enables address decoding
**								 and transaction forwarding of the following VGA transactions from the primary bus 
**									to the secondary bus:
**                                                            frame buffer memory addresses 000A0000h:000BFFFFh, 
**									VGA I/O addresses 3B0:3BBh and 3C0h:3DFh, where AD[31:16]=0000h?**									?and AD[15:10] are either not decoded (i.e., don't cares),
**										 or must be 000000b
**                                                            depending upon the state of the VGA Alias Filter Enable bit. (bit(4) of this register)
**                                                            I/O and Memory Enable bits must be set in the Command register 
**										to enable forwarding of VGA cycles.
** 02           0b                                ISA Enable: Setting this bit enables special handling 
**								for the forwarding of ISA I/O transactions that fall within the address range 
**									specified by the I/O Base and Limit registers, 
**										and are within the lowest 64Kbyte of the I/O address map 
**											(i.e., 0000 0000h - 0000 FFFFh).
**                                                            0b=All I/O transactions that fall within the I/O Base 
**										and Limit registers' specified range are forwarded 
**											from primary to secondary unfiltered.
**                                                            1b=Blocks the forwarding from primary to secondary 
**											of the top 768 bytes of each 1Kbyte alias. 
**												On the secondary the top 768 bytes of each 1K alias 
**													are inversely decoded and forwarded 
**														from secondary to primary.
** 01           0b                      SERR# Forward Enable: 0b=The bridge does not assert P_SERR# as a result of an S_SERR# assertion.
**                                                            1b=The bridge asserts P_SERR# whenever S_SERR# is detected 
**									asserted provided the SERR# Enable bit is set (PCI Command Register bit(8)=1b).
** 00           0b                     Parity Error Response: This bit controls bridge response to a parity error 
**										that is detected on its secondary interface.
**                                                            0b=When a data parity error is detected bridge does not assert S_PERR#. 
**                                                            Also bridge does not assert P_SERR# in response to a detected address 
**										or attribute parity error.
**                                                            1b=When a data parity error is detected bridge asserts S_PERR#. 
**										The bridge also asserts P_SERR# (when enabled globally via bit(8) 
**											of the Command register)
**                                                            in response to a detected address or attribute parity error.
**==============================================================================
*/
#define     ARCMSR_PCI2PCI_BRIDGE_CONTROL_REG	                     0x3E    /*word*/ 
/*
**************************************************************************
**                  Device Specific Registers 40-A7h
**************************************************************************
** ----------------------------------------------------------------------------------------------------------
** |    Byte 3              |         Byte 2         |        Byte 1          |       Byte 0              | Configu-ration Byte Offset
** ----------------------------------------------------------------------------------------------------------
** |    Bridge Control 0    |             Arbiter Control/Status              |      Reserved             | 40h
** ----------------------------------------------------------------------------------------------------------
** |                 Bridge Control 2                |                 Bridge Control 1                   | 44h
** ----------------------------------------------------------------------------------------------------------
** |                    Reserved                     |                 Bridge Status                      | 48h
** ----------------------------------------------------------------------------------------------------------
** |                                             Reserved                                                 | 4Ch
** ----------------------------------------------------------------------------------------------------------
** |                 Prefetch Policy                 |               Multi-Transaction Timer              | 50h
** ----------------------------------------------------------------------------------------------------------
** |       Reserved         |      Pre-boot Status   |             P_SERR# Assertion Control              | 54h
** ----------------------------------------------------------------------------------------------------------
** |       Reserved         |        Reserved        |             Secondary Decode Enable                | 58h
** ----------------------------------------------------------------------------------------------------------
** |                    Reserved                     |                 Secondary IDSEL                    | 5Ch
** ----------------------------------------------------------------------------------------------------------
** |                                              Reserved                                                | 5Ch
** ----------------------------------------------------------------------------------------------------------
** |                                              Reserved                                                | 68h:CBh
** ----------------------------------------------------------------------------------------------------------
**************************************************************************
**==============================================================================
**  0x42-0x41: Secondary Arbiter Control/Status Register - SACSR
** Bit       Default                       Description
** 15:12      1111b                  Grant Time-out Violator: This field indicates the agent that violated the Grant Time-out rule 
**							(PCI=16 clocks,PCI-X=6 clocks). 
**                                   Note that this field is only meaningful when:
**                                                              # Bit[11] of this register is set to 1b, 
**									indicating that a Grant Time-out violation had occurred. 
**                                                              # bridge internal arbiter is enabled.
**                                           Bits[15:12] Violating Agent (REQ#/GNT# pair number)
**                                                 0000b REQ#/GNT#[0]
**                                                 0001b REQ#/GNT#[1]
**                                                 0010b REQ#/GNT#[2]
**                                                 0011b REQ#/GNT#[3]
**                                                 1111b Default Value (no violation detected)
**                                   When bit[11] is cleared by software, this field reverts back to its default value.
**                                   All other values are Reserved
** 11            0b                  Grant Time-out Occurred: When set to 1b, 
**                                   this indicates that a Grant Time-out error had occurred involving one of the secondary bus agents.
**                                   Software clears this bit by writing a 1b to it.
** 10            0b                      Bus Parking Control: 0=During bus idle, bridge parks the bus on the last master to use the bus.
**                                                            1=During bus idle, bridge parks the bus on itself. 
**									The bus grant is removed from the last master and internally asserted to bridge.
** 09:08        00b                          Reserved
** 07:00      0000 0000b  Secondary Bus Arbiter Priority Configuration: The bridge secondary arbiter provides two rings of arbitration priority. 
**                                                                      Each bit of this field assigns its corresponding secondary 
**										bus master to either the high priority arbiter ring (1b) 
**											or to the low priority arbiter ring (0b). 
**                                                                      Bits [3:0] correspond to request inputs S_REQ#[3:0], respectively. 
**                                                                      Bit [6] corresponds to the bridge internal secondary bus request 
**										while Bit [7] corresponds to the SATU secondary bus request. 
**                                                                      Bits [5:4] are unused.
**                                                                      0b=Indicates that the master belongs to the low priority group.
**                                                                      1b=Indicates that the master belongs to the high priority group
**=================================================================================
**  0x43: Bridge Control Register 0 - BCR0
** Bit       Default                       Description
** 07           0b                  Fully Dynamic Queue Mode: 0=The number of Posted write transactions is limited to eight 
**									and the Posted Write data is limited to 4KB.
**                                                            1=Operation in fully dynamic queue mode. The bridge enqueues up to 
**									14 Posted Memory Write transactions and 8KB of posted write data.
** 06:03        0H                          Reserved.
** 02           0b                 Upstream Prefetch Disable: This bit disables bridge ability 
**									to perform upstream prefetch operations for Memory 
**										Read requests received on its secondary interface. 
**                                 This bit also controls the bridge's ability to generate advanced read commands 
**								when forwarding a Memory Read Block transaction request upstream from a PCI-X bus 
**										to a Conventional PCI bus.
**                                 0b=bridge treats all upstream Memory Read requests as though they target prefetchable memory.
**										The use of Memory Read Line and Memory Read
**                                      Multiple is enabled when forwarding a PCI-X Memory Read Block request 
**										to an upstream bus operating in Conventional PCI mode.
**                                 1b=bridge treats upstream PCI Memory Read requests as though 
**									they target non-prefetchable memory and forwards upstream PCI-X Memory 
**											Read Block commands as Memory Read 
**												when the primary bus is operating 
**													in Conventional PCI mode.
**                                 NOTE: This bit does not affect bridge ability to perform read prefetching 
**									when the received command is Memory Read Line or Memory Read Multiple.
**=================================================================================
**  0x45-0x44: Bridge Control Register 1 - BCR1 (Sheet 2 of 2)
** Bit       Default                       Description
** 15:08    0000000b                         Reserved
** 07:06         00b                   Alias Command Mapping: This two bit field determines how bridge handles PCI-X Alias commands, 
**								specifically the Alias to Memory Read Block and Alias to Memory Write Block commands. 
**                                                            The three options for handling these alias commands are to either pass it as is, 
**									re-map to the actual block memory read/write command encoding, or ignore
**                                                            			the transaction forcing a Master Abort to occur on the Origination Bus.
**                                                   Bit (7:6) Handling of command
**                                                        0 0 Re-map to Memory Read/Write Block before forwarding
**                                                        0 1 Enqueue and forward the alias command code unaltered
**                                                        1 0 Ignore the transaction, forcing Master Abort
**                                                        1 1 Reserved
** 05            1b                  Watchdog Timers Disable: Disables or enables all 2 24 Watchdog Timers in both directions. 
**                                                            The watchdog timers are used to detect prohibitively long latencies in the system. 
**                                                            The watchdog timer expires when any Posted Memory Write (PMW), Delayed Request, 
**                                                            or Split Requests (PCI-X mode) is not completed within 2 24 events 
**                                                            (events are defined as PCI Clocks when operating in PCI-X mode, 
**								and as the number of times being retried when operating in Conventional PCI mode)
**                                                            0b=All 2 24 watchdog timers are enabled.
**                                                            1b=All 2 24 watchdog timers are disabled and there is no limits to 
**									the number of attempts bridge makes when initiating a PMW, 
**                                                                 transacting a Delayed Transaction, or how long it waits for 
**									a split completion corresponding to one of its requests.
** 04            0b                  GRANT# time-out disable: This bit enables/disables the GNT# time-out mechanism. 
**                                                            Grant time-out is 16 clocks for conventional PCI, and 6 clocks for PCI-X.
**                                                            0b=The Secondary bus arbiter times out an agent 
**									that does not assert FRAME# within 16/6 clocks of receiving its grant, 
**										once the bus has gone idle. 
**                                                                 The time-out counter begins as soon as the bus goes idle with the new GNT# asserted. 
**                                                                 An infringing agent does not receive a subsequent GNT# 
**									until it de-asserts its REQ# for at least one clock cycle.
**                                                            1b=GNT# time-out mechanism is disabled.
** 03           00b                           Reserved.
** 02            0b          Secondary Discard Timer Disable: This bit enables/disables bridge secondary delayed transaction discard mechanism.
**                                                            The time out mechanism is used to ensure that initiators 
**									of delayed transactions return for their delayed completion data/status 
**										within a reasonable amount of time after it is available from bridge.
**                                                            0b=The secondary master time-out counter is enabled 
**										and uses the value specified by the Secondary Discard Timer bit 
**											(see Bridge Control Register).
**                                                            1b=The secondary master time-out counter is disabled. 
**											The bridge waits indefinitely for a secondary bus master 
**												to repeat a delayed transaction.
** 01            0b            Primary Discard Timer Disable: This bit enables/disables bridge primary delayed transaction discard mechanism. 
**								The time out mechanism is used to ensure that initiators 
**									of delayed transactions return for their delayed completion data/status 
**										within a reasonable amount of time after it is available from bridge.
**                                                            0b=The primary master time-out counter is enabled and uses the value specified 
**									by the Primary Discard Timer bit (see Bridge Control Register).
**                                                            1b=The secondary master time-out counter is disabled. 
**									The bridge waits indefinitely for a secondary bus master 
**										to repeat a delayed transaction.
** 00            0b                           Reserved
**=================================================================================
**  0x47-0x46: Bridge Control Register 2 - BCR2
** Bit       Default                       Description
** 15:07      0000b                          Reserved.
** 06            0b Global Clock Out Disable (External Secondary Bus Clock Source Enable): 
**									This bit disables all of the secondary PCI clock outputs including 
**										the feedback clock S_CLKOUT. 
**                                                            This means that the user is required to provide an S_CLKIN input source.
** 05:04        11 (66 MHz)                  Preserved.
**              01 (100 MHz)
**              00 (133 MHz)
** 03:00        Fh (100 MHz & 66 MHz)
**              7h (133 MHz)
**                                        This 4 bit field provides individual enable/disable mask bits for each of bridge
**                                        secondary PCI clock outputs. Some, or all secondary clock outputs (S_CLKO[3:0])
**                                        default to being enabled following the rising edge of P_RST#, depending on the
**                                        frequency of the secondary bus clock:
**                                               E Designs with 100 MHz (or lower) Secondary PCI clock power up with 
**								all four S_CLKOs enabled by default. (SCLKO[3:0])P
**                                               E Designs with 133 MHz Secondary PCI clock power up 
**								with the lower order 3 S_CLKOs enabled by default. 
**								(S_CLKO[2:0]) Only those SCLKs that power up enabled by can be connected 
**								to downstream device clock inputs.
**=================================================================================
**  0x49-0x48: Bridge Status Register - BSR
** Bit       Default                       Description
** 15           0b  Upstream Delayed Transaction Discard Timer Expired: This bit is set to a 1b and P_SERR# 
**									is conditionally asserted when the secondary discard timer expires.
** 14           0b  Upstream Delayed/Split Read Watchdog Timer Expired: 
**                                                     Conventional PCI Mode: This bit is set to a 1b and P_SERR#
**									is conditionally asserted when bridge discards an upstream delayed read **	**									transaction request after 2 24 retries following the initial retry.
**                                                                PCI-X Mode: This bit is set to a 1b and P_SERR# is conditionally asserted 
**									when bridge discards an upstream split read request 
**									after waiting in excess of 2 24 clocks for the corresponding 
**									Split Completion to arrive.
** 13           0b Upstream Delayed/Split Write Watchdog Timer Expired: 
**                                                     Conventional PCI Mode: This bit is set to a 1b and P_SERR# 
**									is conditionally asserted when bridge discards an upstream delayed write **	**									transaction request after 2 24 retries following the initial retry.
**                                                                PCI-X Mode: This bit is set to a 1b and P_SERR# 
**									is conditionally asserted when bridge discards an upstream split write request **									after waiting in excess of 2 24 clocks for the corresponding 
**									Split Completion to arrive.
** 12           0b           Master Abort during Upstream Posted Write: This bit is set to a 1b and P_SERR# 
**									is conditionally asserted when a Master Abort occurs as a result of an attempt, 
**									by bridge, to retire a PMW upstream.
** 11           0b           Target Abort during Upstream Posted Write: This bit is set to a 1b and P_SERR# 
**									is conditionally asserted when a Target Abort occurs as a result of an attempt,
**									by bridge, to retire a PMW upstream.
** 10           0b                Upstream Posted Write Data Discarded: This bit is set to a 1b and P_SERR# 
**									is conditionally asserted when bridge discards an upstream PMW transaction 
**									after receiving 2 24 target retries from the primary bus target
** 09           0b             Upstream Posted Write Data Parity Error: This bit is set to a 1b and P_SERR# 
**									is conditionally asserted when a data parity error is detected by bridge 
**									while attempting to retire a PMW upstream
** 08           0b                  Secondary Bus Address Parity Error: This bit is set to a 1b and P_SERR# 
**									is conditionally asserted when bridge detects an address parity error on 
**									the secondary bus.
** 07           0b Downstream Delayed Transaction Discard Timer Expired: This bit is set to a 1b and P_SERR# 
**									is conditionally asserted when the primary bus discard timer expires.
** 06           0b Downstream Delayed/Split Read Watchdog Timer Expired:
**                                                     Conventional PCI Mode: This bit is set to a 1b and P_SERR# 
**									is conditionally asserted when bridge discards a downstream delayed read **	**										transaction request after receiving 2 24 target retries
**											 from the secondary bus target.
**                                                                PCI-X Mode: This bit is set to a 1b and P_SERR# is conditionally asserted 
**										when bridge discards a downstream split read request 
**											after waiting in excess of 2 24 clocks for the corresponding 
**												Split Completion to arrive.
** 05           0b Downstream Delayed Write/Split Watchdog Timer Expired:
**                                                     Conventional PCI Mode: This bit is set to a 1b and P_SERR# is conditionally asserted 
**									when bridge discards a downstream delayed write transaction request 
**										after receiving 2 24 target retries from the secondary bus target.
**                                                                PCI-X Mode: This bit is set to a 1b and P_SERR# 
**									is conditionally asserted when bridge discards a downstream 
**										split write request after waiting in excess of 2 24 clocks 
**											for the corresponding Split Completion to arrive.
** 04           0b          Master Abort during Downstream Posted Write: This bit is set to a 1b and P_SERR# 
**									is conditionally asserted when a Master Abort occurs as a result of an attempt, 
**										by bridge, to retire a PMW downstream.
** 03           0b          Target Abort during Downstream Posted Write: This bit is set to a 1b and P_SERR# is conditionally asserted 
**										when a Target Abort occurs as a result of an attempt, by bridge, 
**											to retire a PMW downstream.
** 02           0b               Downstream Posted Write Data Discarded: This bit is set to a 1b and P_SERR#
**									is conditionally asserted when bridge discards a downstream PMW transaction 
**										after receiving 2 24 target retries from the secondary bus target
** 01           0b            Downstream Posted Write Data Parity Error: This bit is set to a 1b and P_SERR# 
**									is conditionally asserted when a data parity error is detected by bridge 
**										while attempting to retire a PMW downstream.
** 00           0b                     Primary Bus Address Parity Error: This bit is set to a 1b and P_SERR# is conditionally asserted 
**										when bridge detects an address parity error on the primary bus.
**==================================================================================
**  0x51-0x50: Bridge Multi-Transaction Timer Register - BMTTR
** Bit       Default                       Description
** 15:13       000b                          Reserved
** 12:10       000b                          GRANT# Duration: This field specifies the count (PCI clocks) 
**							that a secondary bus master has its grant maintained in order to enable 
**								multiple transactions to execute within the same arbitration cycle.
**                                                    Bit[02:00] GNT# Extended Duration
**                                                               000 MTT Disabled (Default=no GNT# extension)
**                                                               001 16 clocks
**                                                               010 32 clocks
**                                                               011 64 clocks
**                                                               100 128 clocks
**                                                               101 256 clocks
**                                                               110 Invalid (treated as 000)
**                                                               111 Invalid (treated as 000)
** 09:08        00b                          Reserved
** 07:00        FFh                                 MTT Mask: This field enables/disables MTT usage for each REQ#/GNT# 
**								pair supported by bridge secondary arbiter. 
**                                                            Bit(7) corresponds to SATU internal REQ#/GNT# pair,
**                                                            bit(6) corresponds to bridge internal REQ#/GNT# pair, 
**                                                            bit(5) corresponds to REQ#/GNT#(5) pair, etc.
**                                                  When a given bit is set to 1b, its corresponding REQ#/GNT# 
**								pair is enabled for MTT functionality as determined by bits(12:10) of this register.
**                                                  When a given bit is cleared to 0b, its corresponding REQ#/GNT# pair is disabled from using the MTT.
**==================================================================================
**  0x53-0x52: Read Prefetch Policy Register - RPPR
** Bit       Default                       Description
** 15:13       000b                    ReRead_Primary Bus: 3-bit field indicating the multiplication factor 
**							to be used in calculating the number of bytes to prefetch from the secondary bus interface on **								subsequent PreFetch operations given that the read demands were not satisfied 
**									using the FirstRead parameter.
**                                           The default value of 000b correlates to: Command Type Hardwired pre-fetch amount Memory Read 4 DWORDs 
**							Memory Read Line 1 cache lines Memory Read Multiple 2 cache lines
** 12:10       000b                 FirstRead_Primary Bus: 3-bit field indicating the multiplication factor to be used in calculating 
**							the number of bytes to prefetch from the secondary bus interface 
**								on the initial PreFetch operation.
**                                           The default value of 000b correlates to: Command Type Hardwired pre-fetch amount Memory Read 4 DWORDs 
**								Memory Read Line 1 cache line Memory Read Multiple 2 cache lines
** 09:07       010b                  ReRead_Secondary Bus: 3-bit field indicating the multiplication factor to be used 
**								in calculating the number of bytes to prefetch from the primary 
**									bus interface on subsequent PreFetch operations given 
**										that the read demands were not satisfied using 
**											the FirstRead parameter.
**                                           The default value of 010b correlates to: Command Type Hardwired pre-fetch a
**							mount Memory Read 3 cache lines Memory Read Line 3 cache lines 
**								Memory Read Multiple 6 cache lines
** 06:04       000b               FirstRead_Secondary Bus: 3-bit field indicating the multiplication factor to be used 
**							in calculating the number of bytes to prefetch from 
**								the primary bus interface on the initial PreFetch operation.
**                                           The default value of 000b correlates to: Command Type Hardwired pre-fetch amount 
**							Memory Read 4 DWORDs Memory Read Line 1 cache line Memory Read Multiple 2 cache lines
** 03:00      1111b                Staged Prefetch Enable: This field enables/disables the FirstRead/ReRead pre-fetch 
**							algorithm for the secondary and the primary bus interfaces.
**                                                         Bit(3) is a ganged enable bit for REQ#/GNT#[7:3], and bits(2:0) provide individual
**                                                                            enable bits for REQ#/GNT#[2:0]. 
**							  (bit(2) is the enable bit for REQ#/GNT#[2], etc...)
**                                                                            1b: enables the staged pre-fetch feature
**                                                                            0b: disables staged pre-fetch,
**                                                         and hardwires read pre-fetch policy to the following for 
**                                                         Memory Read, 
**                                                         Memory Read Line, 
**                                                     and Memory Read Multiple commands: 
**                                                     Command Type Hardwired Pre-Fetch Amount...
**                                                                                      Memory Read 4 DWORDs
**                                                                                      Memory Read Line 1 cache line
**                                                                                      Memory Read Multiple 2 cache lines
** NOTE: When the starting address is not cache line aligned, bridge pre-fetches Memory Read line commands 
** only to the next higher cache line boundary.For non-cache line aligned Memory Read 
** Multiple commands bridge pre-fetches only to the second cache line boundary encountered.
**==================================================================================
**  0x55-0x54: P_SERR# Assertion Control - SERR_CTL
** Bit       Default                       Description
**  15          0b   Upstream Delayed Transaction Discard Timer Expired: Dictates the bridge behavior 
** 						in response to its discarding of a delayed transaction that was initiated from the primary bus.
**                                                                       0b=bridge asserts P_SERR#.
**                                                                       1b=bridge does not assert P_SERR#
**  14          0b   Upstream Delayed/Split Read Watchdog Timer Expired: Dictates bridge behavior following expiration of the subject watchdog timer.
**                                                                       0b=bridge asserts P_SERR#.
**                                                                       1b=bridge does not assert P_SERR#
**  13          0b   Upstream Delayed/Split Write Watchdog Timer Expired: Dictates bridge behavior following expiration of the subject watchdog timer.
**                                                                       0b=bridge asserts P_SERR#.
**                                                                       1b=bridge does not assert P_SERR#
**  12          0b             Master Abort during Upstream Posted Write: Dictates bridge behavior following 
**						its having detected a Master Abort while attempting to retire one of its PMWs upstream.
**                                                                       0b=bridge asserts P_SERR#.
**                                                                       1b=bridge does not assert P_SERR#
**  11          0b             Target Abort during Upstream Posted Write: Dictates bridge behavior following 
**						its having been terminated with Target Abort while attempting to retire one of its PMWs upstream.
**                                                                       0b=bridge asserts P_SERR#.
**                                                                       1b=bridge does not assert P_SERR#
**  10          0b                  Upstream Posted Write Data Discarded: Dictates bridge behavior in the event that 
**						it discards an upstream posted write transaction.
**                                                                       0b=bridge asserts P_SERR#.
**                                                                       1b=bridge does not assert P_SERR#
**  09          0b               Upstream Posted Write Data Parity Error: Dictates bridge behavior 
**						when a data parity error is detected while attempting to retire on of its PMWs upstream.
**                                                                       0b=bridge asserts P_SERR#.
**                                                                       1b=bridge does not assert P_SERR#
**  08          0b                    Secondary Bus Address Parity Error: This bit dictates bridge behavior 
**						when it detects an address parity error on the secondary bus.
**                                                                       0b=bridge asserts P_SERR#.
**                                                                       1b=bridge does not assert P_SERR#
**  07          0b  Downstream Delayed Transaction Discard Timer Expired: Dictates bridge behavior in response to 
**						its discarding of a delayed transaction that was initiated on the secondary bus.
**                                                                       0b=bridge asserts P_SERR#.
**                                                                       1b=bridge does not assert P_SERR#
**  06          0b  Downstream Delayed/Split Read Watchdog Timer Expired: Dictates bridge behavior following expiration of the subject watchdog timer.
**                                                                       0b=bridge asserts P_SERR#.
**                                                                       1b=bridge does not assert P_SERR#
**  05          0b Downstream Delayed/Split Write Watchdog Timer Expired: Dictates bridge behavior following expiration of the subject watchdog timer.
**                                                                       0b=bridge asserts P_SERR#.
**                                                                       1b=bridge does not assert P_SERR#
**  04          0b           Master Abort during Downstream Posted Write: Dictates bridge behavior following 
**						its having detected a Master Abort while attempting to retire one of its PMWs downstream.
**                                                                       0b=bridge asserts P_SERR#.
**                                                                       1b=bridge does not assert P_SERR#
**  03          0b           Target Abort during Downstream Posted Write: Dictates bridge behavior following 
**						its having been terminated with Target Abort while attempting to retire one of its PMWs downstream.
**                                                                       0b=bridge asserts P_SERR#.
**                                                                       1b=bridge does not assert P_SERR#
**  02          0b                Downstream Posted Write Data Discarded: Dictates bridge behavior in the event 
**						that it discards a downstream posted write transaction.
**                                                                       0b=bridge asserts P_SERR#.
**                                                                       1b=bridge does not assert P_SERR#
**  01          0b             Downstream Posted Write Data Parity Error: Dictates bridge behavior 
**						when a data parity error is detected while attempting to retire on of its PMWs downstream.
**                                                                       0b=bridge asserts P_SERR#.
**                                                                       1b=bridge does not assert P_SERR#
**  00          0b                      Primary Bus Address Parity Error: This bit dictates bridge behavior 
**						when it detects an address parity error on the primary bus.
**                                                                       0b=bridge asserts P_SERR#.
**                                                                       1b=bridge does not assert P_SERR#
**===============================================================================
**  0x56: Pre-Boot Status Register - PBSR
** Bit       Default                       							Description
** 07           1                          							 Reserved
** 06           -                          							 Reserved - value indeterminate
** 05:02        0                          							 Reserved
** 01      Varies with External State of S_133EN at PCI Bus Reset    Secondary Bus Max Frequency Setting:
**									 This bit reflect captured S_133EN strap, 
**										indicating the maximum secondary bus clock frequency when in PCI-X mode.
**                                                                   Max Allowable Secondary Bus Frequency
**																			**						S_133EN PCI-X Mode
**																			**						0 100 MHz
**																			**						1 133 MH
** 00          0b                                                    Reserved
**===============================================================================
**  0x59-0x58: Secondary Decode Enable Register - SDER
** Bit       Default                       							Description
** 15:03      FFF1h                        							 Preserved.
** 02     Varies with External State of PRIVMEM at PCI Bus Reset   Private Memory Space Enable - when set, 
**									bridge overrides its secondary inverse decode logic and not
**                                                                 forward upstream any secondary bus initiated DAC Memory transactions with AD(63)=1b.
**                                                                 This creates a private memory space on the Secondary PCI bus 
**									that allows peer-to-peer transactions.
** 01:00      10 2                                                   Preserved.
**===============================================================================
**  0x5D-0x5C: Secondary IDSEL Select Register - SISR
** Bit       Default                       							Description
** 15:10     000000 2                      							 Reserved.
** 09    Varies with External State of PRIVDEV at PCI Bus Reset     AD25- IDSEL Disable - When this bit is set, 
**							AD25 is deasserted for any possible Type 1 to Type 0 conversion.
**                                                                                        When this bit is clear, 
**							AD25 is asserted when Primary addresses AD[15:11]=01001 2 during a Type 1 to Type 0 conversion.
** 08    Varies with External State of PRIVDEV at PCI Bus Reset     AD24- IDSEL Disable - When this bit is set, 
**							AD24 is deasserted for any possible Type 1 to Type 0 conversion.
**                                                                                        When this bit is clear, 
**							AD24 is asserted when Primary addresses AD[15:11]=01000 2 during a Type 1 to Type 0 conversion.
** 07    Varies with External State of PRIVDEV at PCI Bus Reset     AD23- IDSEL Disable - When this bit is set, 
**							AD23 is deasserted for any possible Type 1 to Type 0 conversion. 
**                                                                                        When this bit is clear, 
**							AD23 is asserted when Primary addresses AD[15:11]=00111 2 during a Type 1 to Type 0 conversion.
** 06    Varies with External State of PRIVDEV at PCI Bus Reset     AD22- IDSEL Disable - When this bit is set, 
**							AD22 is deasserted for any possible Type 1 to Type 0 conversion.
**                                                                                        When this bit is clear, 
**							AD22 is asserted when Primary addresses AD[15:11]=00110 2 during a Type 1 to Type 0 conversion.
** 05    Varies with External State of PRIVDEV at PCI Bus Reset     AD21- IDSEL Disable - When this bit is set, 
**							AD21 is deasserted for any possible Type 1 to Type 0 conversion.
**                                                                                        When this bit is clear, 
**							AD21 is asserted when Primary addresses AD[15:11]=00101 2 during a Type 1 to Type 0 conversion.
** 04    Varies with External State of PRIVDEV at PCI Bus Reset     AD20- IDSEL Disable - When this bit is set, 
**							AD20 is deasserted for any possible Type 1 to Type 0 conversion.
**                                                                                        When this bit is clear, 
**							AD20 is asserted when Primary addresses AD[15:11]=00100 2 during a Type 1 to Type 0 conversion.
** 03    Varies with External State of PRIVDEV at PCI Bus Reset     AD19- IDSEL Disable - When this bit is set, 
**							AD19 is deasserted for any possible Type 1 to Type 0 conversion.
**                                                                                        When this bit is clear,
**							AD19 is asserted when Primary addresses AD[15:11]=00011 2 during a Type 1 to Type 0 conversion.
** 02    Varies with External State of PRIVDEV at PCI Bus Reset     AD18- IDSEL Disable - When this bit is set, 
**							AD18 is deasserted for any possible Type 1 to Type 0 conversion.
**                                                                                        When this bit is clear,
**							AD18 is asserted when Primary addresses AD[15:11]=00010 2 during a Type 1 to Type 0 conversion.
** 01    Varies with External State of PRIVDEV at PCI Bus Reset     AD17- IDSEL Disable - When this bit is set, 
**							AD17 is deasserted for any possible Type 1 to Type 0 conversion.
**                                                                                        When this bit is clear, 
**							AD17 is asserted when Primary addresses AD[15:11]=00001 2 during a Type 1 to Type 0 conversion.
** 00    Varies with External State of PRIVDEV at PCI Bus Reset     AD16- IDSEL Disable - When this bit is set, 
**							AD16 is deasserted for any possible Type 1 to Type 0 conversion.
**                                                                                        When this bit is clear, 
**							AD16 is asserted when Primary addresses AD[15:11]=00000 2 during a Type 1 to Type 0 conversion.
**************************************************************************
*/
/*
**************************************************************************
**                 Reserved      A8-CBh           
**************************************************************************
*/
/*
**************************************************************************
**                  PCI Extended Enhanced Capabilities List CC-FFh
**************************************************************************
** ----------------------------------------------------------------------------------------------------------
** |    Byte 3              |         Byte 2         |        Byte 1          |       Byte 0              | Configu-ration Byte Offset
** ----------------------------------------------------------------------------------------------------------
** |           Power Management Capabilities         |        Next Item Ptr   |     Capability ID         | DCh
** ----------------------------------------------------------------------------------------------------------
** |        PM Data         |       PPB Support      |            Extensions Power Management CSR         | E0h
** ----------------------------------------------------------------------------------------------------------
** |                    Reserved                     |        Reserved        |        Reserved           | E4h
** ----------------------------------------------------------------------------------------------------------
** |                                              Reserved                                                | E8h
** ----------------------------------------------------------------------------------------------------------
** |       Reserved         |        Reserved        |        Reserved        |         Reserved          | ECh
** ----------------------------------------------------------------------------------------------------------
** |              PCI-X Secondary Status             |       Next Item Ptr    |       Capability ID       | F0h
** ----------------------------------------------------------------------------------------------------------
** |                                         PCI-X Bridge Status                                          | F4h
** ----------------------------------------------------------------------------------------------------------
** |                                PCI-X Upstream Split Transaction Control                              | F8h
** ----------------------------------------------------------------------------------------------------------
** |                               PCI-X Downstream Split Transaction Control                             | FCh
** ----------------------------------------------------------------------------------------------------------
**===============================================================================
**  0xDC: Power Management Capabilities Identifier - PM_CAPID
** Bit       Default                       Description
** 07:00       01h                        Identifier (ID): PCI SIG assigned ID for PCI-PM register block
**===============================================================================
**  0xDD: Next Item Pointer - PM_NXTP
** Bit       Default                       Description
** 07:00       F0H                Next Capabilities Pointer (PTR): The register defaults to F0H pointing to the PCI-X Extended Capability Header.
**===============================================================================
**  0xDF-0xDE: Power Management Capabilities Register - PMCR
** Bit       Default                       Description
** 15:11       00h                     PME Supported (PME): PME# cannot be asserted by bridge.
** 10           0h                 State D2 Supported (D2): Indicates no support for state D2. No power management action in this state.
** 09           1h                 State D1 Supported (D1): Indicates support for state D1. No power management action in this state.
** 08:06        0h                Auxiliary Current (AUXC): This 3 bit field reports the 3.3Vaux auxiliary current requirements for the PCI function. 
**                                                          This returns 000b as PME# wake-up for bridge is not implemented.
** 05           0   Special Initialization Required (SINT): Special initialization is not required for bridge.
** 04:03       00                            Reserved
** 02:00       010                            Version (VS): Indicates that this supports PCI Bus Power Management Interface Specification, Revision 1.1.
**===============================================================================
**  0xE1-0xE0: Power Management Control / Status - Register - PMCSR
** Bit       Default                       Description
** 15:09       00h                          Reserved
** 08          0b                          PME_Enable: This bit, when set to 1b enables bridge to assert PME#. 
**	Note that bridge never has occasion to assert PME# and implements this dummy R/W bit only for the purpose of working around an OS PCI-PM bug.
** 07:02       00h                          Reserved
** 01:00       00                Power State (PSTATE): This 2-bit field is used both to determine the current power state of 
**									a function and to set the Function into a new power state.
**  													00 - D0 state
**  													01 - D1 state
**  													10 - D2 state
**  													11 - D3 hot state
**===============================================================================
**  0xE2: Power Management Control / Status PCI to PCI Bridge Support - PMCSR_BSE
** Bit       Default                       Description
** 07          0         Bus Power/Clock Control Enable (BPCC_En): Indicates that the bus power/clock control policies have been disabled.
** 06          0                B2/B3 support for D3 Hot (B2_B3#): The state of this bit determines the action that 
**									is to occur as a direct result of programming the function to D3 hot.
**                                                                 This bit is only meaningful when bit 7 (BPCC_En) is a 1.
** 05:00     00h                            Reserved
**===============================================================================
**  0xE3: Power Management Data Register - PMDR
** Bit       Default                       Description
** 07:00       00h                          Reserved
**===============================================================================
**  0xF0: PCI-X Capabilities Identifier - PX_CAPID
** Bit       Default                       Description
** 07:00       07h                       Identifier (ID): Indicates this is a PCI-X capabilities list.
**===============================================================================
**  0xF1: Next Item Pointer - PX_NXTP
** Bit       Default                       Description
** 07:00       00h                     Next Item Pointer: Points to the next capability in the linked list The power on default value of this
**                                                        register is 00h indicating that this is the last entry in the linked list of capabilities.
**===============================================================================
**  0xF3-0xF2: PCI-X Secondary Status - PX_SSTS
** Bit       Default                       Description
** 15:09       00h                          Reserved
** 08:06       Xxx                Secondary Clock Frequency (SCF): This field is set with the frequency of the secondary bus. 
**                                                                 The values are:
** 																			**		BitsMax FrequencyClock Period
** 																			**		000PCI ModeN/A
** 																			**		00166 15
** 																			**		01010010
** 																			**		0111337.5
** 																			**		1xxreservedreserved
** 																			**		The default value for this register is the operating frequency of the secondary bus
** 05           0b                   Split Request Delayed. (SRD):  This bit is supposed to be set by a bridge when it cannot forward a transaction on the
** 						secondary bus to the primary bus because there is not enough room within the limit
** 						specified in the Split Transaction Commitment Limit field in the Downstream Split
** 						Transaction Control register. The bridge does not set this bit.
** 04           0b                 Split Completion Overrun (SCO): This bit is supposed to be set when a bridge terminates a Split Completion on the **	**						secondary bus with retry or Disconnect at next ADB because its buffers are full. 
**						The bridge does not set this bit.
** 03           0b              Unexpected Split Completion (USC): This bit is set when an unexpected split completion with a requester ID 
**						equal to bridge secondary bus number, device number 00h,
**						and function number 0 is received on the secondary interface. 
**						This bit is cleared by software writing a '1'.
** 02           0b               Split Completion Discarded (SCD): This bit is set 
**						when bridge discards a split completion moving toward the secondary bus 
**						because the requester would not accept it. This bit cleared by software writing a '1'.
** 01           1b                                133 MHz Capable: Indicates that bridge is capable of running its secondary bus at 133 MHz
** 00           1b                            64-bit Device (D64): Indicates the width of the secondary bus as 64-bits.
**===============================================================================
**  0xF7-0xF6-0xf5-0xF4: PCI-X Bridge Status - PX_BSTS
** Bit       Default      								                 Description
** 31:22        0         								                  Reserved
** 21           0         							Split Request Delayed (SRD): This bit does not be set by bridge.
** 20           0         							Split Completion Overrun (SCO): This bit does not be set by bridge
**										because bridge throttles traffic on the completion side.
** 19           0         							Unexpected Split Completion (USC): The bridge sets this bit to 1b 
**										when it encounters a corrupted Split Completion, possibly with an **	**										inconsistent remaining byte count.Software clears 
**										this bit by writing a 1b to it.
** 18           0         							Split Completion Discarded (SCD): The bridge sets this bit to 1b 
**										when it has discarded a Split Completion.Software clears this bit by **	**										writing a 1b to it.
** 17           1         							133 MHz Capable: This bit indicates that the bridge primary interface is **										capable of 133 MHz operation in PCI-X mode.
**										0=The maximum operating frequency is 66 MHz.
**										1=The maximum operating frequency is 133 MHz.
** 16 Varies with the external state of P_32BITPCI# at PCI Bus Reset    64-bit Device (D64): Indicates bus width of the Primary PCI bus interface.
**										 0=Primary Interface is connected as a 32-bit PCI bus.
**										 1=Primary Interface is connected as a 64-bit PCI bus.
** 15:08       00h 								Bus Number (BNUM): This field is simply an alias to the PBN field 
**											of the BNUM register at offset 18h.
**								Apparently it was deemed necessary reflect it here for diagnostic purposes.
** 07:03       1fh						Device Number (DNUM): Indicates which IDSEL bridge consumes. 
**								May be updated whenever a PCI-X
**								 configuration write cycle that targets bridge scores a hit.
** 02:00        0h                                                   Function Number (FNUM): The bridge Function #
**===============================================================================
**  0xFB-0xFA-0xF9-0xF8: PCI-X Upstream Split Transaction Control - PX_USTC
** Bit       Default                       Description
** 31:16      003Eh                 Split Transaction Limit (STL): This register indicates the size of the commitment limit in units of ADQs.
**                                                                 Software is permitted to program this register to any value greater than or equal to
**                                                                 the contents of the Split Transaction Capacity register. A value less than the contents
**                                                                 of the Split Transaction Capacity register causes unspecified results.
**                                                                 A value of 003Eh or greater enables the bridge to forward all Split Requests of any
**                                                                 size regardless of the amount of buffer space available.
** 15:00      003Eh              Split Transaction Capacity (STC): This read-only field indicates the size of the buffer (number of ADQs) for storing
** 				   split completions. This register controls behavior of the bridge buffers for forwarding
** 				   Split Transactions from a primary bus requester to a secondary bus completer.
** 				   The default value of 003Eh indicates there is available buffer space for 62 ADQs (7936 bytes).
**===============================================================================
**  0xFF-0xFE-0xFD-0xFC: PCI-X Downstream Split Transaction Control - PX_DSTC
** Bit       Default                       Description
** 31:16      003Eh                 Split Transaction Limit (STL):  This register indicates the size of the commitment limit in units of ADQs.
**							Software is permitted to program this register to any value greater than or equal to
**							the contents of the Split Transaction Capacity register. A value less than the contents
**							of the Split Transaction Capacity register causes unspecified results.
**							A value of 003Eh or greater enables the bridge to forward all Split Requests of any
**							size regardless of the amount of buffer space available.
** 15:00      003Eh              Split Transaction Capacity (STC): This read-only field indicates the size of the buffer (number of ADQs) for storing
**                                                                 split completions. This register controls behavior of the bridge buffers for forwarding
**                                                                 Split Transactions from a primary bus requester to a secondary bus completer.
**                                                                 The default value of 003Eh indicates there is available buffer space for 62 ADQs 
**									(7936 bytes).
**************************************************************************
*/




/*
*************************************************************************************************************************************
**                       80331 Address Translation Unit Register Definitions
**                               ATU Interface Configuration Header Format
**               The ATU is programmed via a [Type 0] configuration command on the PCI interface.
*************************************************************************************************************************************
** |    Byte 3              |         Byte 2         |        Byte 1          |       Byte 0              | Configuration Byte Offset
**===================================================================================================================================
** |                ATU Device ID                    |                     Vendor ID                      | 00h
** ----------------------------------------------------------------------------------------------------------
** |                     Status                      |                     Command                        | 04H
** ----------------------------------------------------------------------------------------------------------
** |                              ATU Class Code                              |       Revision ID         | 08H
** ----------------------------------------------------------------------------------------------------------
** |         ATUBISTR       |     Header Type        |      Latency Timer     |      Cacheline Size       | 0CH
** ----------------------------------------------------------------------------------------------------------
** |                                     Inbound ATU Base Address 0                                       | 10H
** ----------------------------------------------------------------------------------------------------------
** |                               Inbound ATU Upper Base Address 0                                       | 14H
** ----------------------------------------------------------------------------------------------------------
** |                                     Inbound ATU Base Address 1                                       | 18H
** ----------------------------------------------------------------------------------------------------------
** |                               Inbound ATU Upper Base Address 1                                       | 1CH
** ----------------------------------------------------------------------------------------------------------
** |                                     Inbound ATU Base Address 2                                       | 20H
** ----------------------------------------------------------------------------------------------------------
** |                               Inbound ATU Upper Base Address 2                                       | 24H
** ----------------------------------------------------------------------------------------------------------
** |                                             Reserved                                                 | 28H   
** ----------------------------------------------------------------------------------------------------------
** |                ATU Subsystem ID                 |                ATU Subsystem Vendor ID             | 2CH
** ----------------------------------------------------------------------------------------------------------
** |                                       Expansion ROM Base Address                                     | 30H
** ----------------------------------------------------------------------------------------------------------
** |                                    Reserved Capabilities Pointer                                     | 34H
** ----------------------------------------------------------------------------------------------------------
** |                                             Reserved                                                 | 38H
** ----------------------------------------------------------------------------------------------------------
** |     Maximum Latency    |     Minimum Grant      |       Interrupt Pin    |      Interrupt Line       | 3CH
** ----------------------------------------------------------------------------------------------------------
*********************************************************************************************************************
*/
/*
***********************************************************************************
**  ATU Vendor ID Register - ATUVID
**  -----------------------------------------------------------------
**  Bit       Default                       Description
**  15:00      8086H (0x17D3)               ATU Vendor ID - This is a 16-bit value assigned to Intel. 
**						This register, combined with the DID, uniquely identify the PCI device. 
**      Access type is Read/Write to allow the 80331 to configure the register as a different vendor ID 
**	to simulate the interface of a standard mechanism currently used by existing application software.
***********************************************************************************
*/
#define     ARCMSR_ATU_VENDOR_ID_REG		         0x00    /*word*/
/*
***********************************************************************************
**  ATU Device ID Register - ATUDID
**  -----------------------------------------------------------------
**  Bit       Default                       Description
**  15:00      0336H (0x1110)               ATU Device ID - This is a 16-bit value assigned to the ATU. 
**	This ID, combined with the VID, uniquely identify any PCI device.
***********************************************************************************
*/
#define     ARCMSR_ATU_DEVICE_ID_REG		         0x02    /*word*/
/*
***********************************************************************************
**  ATU Command Register - ATUCMD
**  -----------------------------------------------------------------
**  Bit       Default                       Description
**  15:11      000000 2                     Reserved
**  10           0                          Interrupt Disable - This bit disables 80331 from asserting the ATU interrupt signal.
**                                                              0=enables the assertion of interrupt signal.
**                                                              1=disables the assertion of its interrupt signal.
**  09          0 2                         Fast Back to Back Enable - When cleared, 
**						the ATU interface is not allowed to generate fast back-to-back cycles on its bus.
**						Ignored when operating in the PCI-X mode.
**  08          0 2                         SERR# Enable - When cleared, the ATU interface is not allowed to assert SERR# on the PCI interface.
**  07          1 2                         Address/Data Stepping Control - Address stepping is implemented for configuration transactions. The
**                                          ATU inserts 2 clock cycles of address stepping for Conventional Mode and 4 clock cycles 
**						of address stepping for PCI-X mode.
**  06          0 2                         Parity Error Response - When set, the ATU takes normal action when a parity error 
**						is detected. When cleared, parity checking is disabled.
**  05          0 2                         VGA Palette Snoop Enable - The ATU interface does not support I/O writes and therefore, 
**						does not perform VGA palette snooping.
**  04          0 2                         Memory Write and Invalidate Enable - When set, ATU may generate MWI commands. 
**						When clear, ATU use Memory Write commands instead of MWI. Ignored when operating in the PCI-X mode.
**  03          0 2                         Special Cycle Enable - The ATU interface does not respond to special cycle commands in any way. 
**						Not implemented and a reserved bit field.
**  02          0 2                         Bus Master Enable - The ATU interface can act as a master on the PCI bus. 
**						When cleared, disables the device from generating PCI accesses. 
**						When set, allows the device to behave as a PCI bus master.
**                                          When operating in the PCI-X mode, ATU initiates a split completion transaction regardless 
**						of the state of this bit.
**  01          0 2                         Memory Enable - Controls the ATU interfaces response to PCI memory addresses. 
**						When cleared, the ATU interface does not respond to any memory access on the PCI bus.
**  00          0 2                         I/O Space Enable - Controls the ATU interface response to I/O transactions. 
**						Not implemented and a reserved bit field.
***********************************************************************************
*/
#define     ARCMSR_ATU_COMMAND_REG		         0x04    /*word*/
/*
***********************************************************************************
**  ATU Status Register - ATUSR (Sheet 1 of 2)
**  -----------------------------------------------------------------
**  Bit       Default                       Description
**  15          0 2                         Detected Parity Error - set when a parity error is detected in data received by the ATU on the PCI bus even
**  					when the ATUCMD registers Parity Error Response bit is cleared. Set under the following conditions:
**  										E Write Data Parity Error when the ATU is a target (inbound write).
**  										E Read Data Parity Error when the ATU is a requester (outbound read).
**  										E Any Address or Attribute (PCI-X Only) Parity Error on the Bus **	** **  								(including one generated by the ATU).
**  14          0 2                         SERR# Asserted - set when SERR# is asserted on the PCI bus by the ATU.
**  13          0 2                         Master Abort - set when a transaction initiated by the ATU PCI master interface, ends in a Master-Abort
**                                          or when the ATU receives a Master Abort Split Completion Error Message in PCI-X mode.
**  12          0 2                         Target Abort (master) - set when a transaction initiated by the ATU PCI master interface, ends in a target
**                                          abort or when the ATU receives a Target Abort Split Completion Error Message in PCI-X mode.
**  11          0 2                         Target Abort (target) - set when the ATU interface, acting as a target, 
**						terminates the transaction on the PCI bus with a target abort.
**  10:09       01 2                        DEVSEL# Timing - These bits are read-only and define the slowest DEVSEL# 
**						timing for a target device in Conventional PCI Mode regardless of the operating mode 
**							(except configuration accesses).
**  										00 2=Fast
**  										01 2=Medium
**  										10 2=Slow
**  										11 2=Reserved
**                                          The ATU interface uses Medium timing.
**  08           0 2                        Master Parity Error - The ATU interface sets this bit under the following conditions:
**  										E The ATU asserted PERR# itself or the ATU observed PERR# asserted.
**  										E And the ATU acted as the requester 
**											for the operation in which the error occurred.
**  										E And the ATUCMD registers Parity Error Response bit is set
**  										E Or (PCI-X Mode Only) the ATU received a Write Data Parity Error Message
**  										E And the ATUCMD registers Parity Error Response bit is set
**  07           1 2  (Conventional mode)
**               0 2  (PCI-X mode)
**  							Fast Back-to-Back - The ATU/Messaging Unit interface is capable of accepting fast back-to-back
**  							transactions in Conventional PCI mode when the transactions are not to the same target. Since fast
**  							back-to-back transactions do not exist in PCI-X mode, this bit is forced to 0 in the PCI-X mode.
**  06           0 2                        UDF Supported - User Definable Features are not supported
**  05           1 2                        66 MHz. Capable - 66 MHz operation is supported.
**  04           1 2                        Capabilities - When set, this function implements extended capabilities.
**  03             0                        Interrupt Status - reflects the state of the ATU interrupt 
**						when the Interrupt Disable bit in the command register is a 0.
**  										0=ATU interrupt signal deasserted.
**  										1=ATU interrupt signal asserted.
**  		NOTE: Setting the Interrupt Disable bit to a 1 has no effect on the state of this bit. Refer to
**  		Section 3.10.23, ATU Interrupt Pin Register - ATUIPR on page 236 for details on the ATU
**  										interrupt signal.
**  02:00      00000 2                      Reserved.
***********************************************************************************
*/
#define     ARCMSR_ATU_STATUS_REG		         0x06    /*word*/
/*
***********************************************************************************
**  ATU Revision ID Register - ATURID
**  -----------------------------------------------------------------
**  Bit       Default                       Description
**  07:00        00H                        ATU Revision - identifies the 80331 revision number.
***********************************************************************************
*/
#define     ARCMSR_ATU_REVISION_REG		         0x08    /*byte*/
/*
***********************************************************************************
**  ATU Class Code Register - ATUCCR
**  -----------------------------------------------------------------
**  Bit       Default                       Description
**  23:16        05H                        Base Class - Memory Controller
**  15:08        80H                        Sub Class - Other Memory Controller
**  07:00        00H                        Programming Interface - None defined
***********************************************************************************
*/
#define     ARCMSR_ATU_CLASS_CODE_REG		         0x09    /*3bytes 0x0B,0x0A,0x09*/
/*
***********************************************************************************
**  ATU Cacheline Size Register - ATUCLSR
**  -----------------------------------------------------------------
**  Bit       Default                       Description
**  07:00        00H                        ATU Cacheline Size - specifies the system cacheline size in DWORDs. Cacheline size is restricted to either 0, 8 or 16 DWORDs.
***********************************************************************************
*/
#define     ARCMSR_ATU_CACHELINE_SIZE_REG		         0x0C    /*byte*/
/*
***********************************************************************************
**  ATU Latency Timer Register - ATULT
**  -----------------------------------------------------------------
**  Bit       Default                       Description
**  07:03     00000 2   (for Conventional mode)
**            01000 2   (for PCI-X mode)
**  			Programmable Latency Timer - This field varies the latency timer for the interface from 0 to 248 clocks.
**  			The default value is 0 clocks for Conventional PCI mode, and 64 clocks for PCI-X mode.
**  02:00       000 2   Latency Timer Granularity - These Bits are read only giving a programmable granularity of 8 clocks for the latency timer.
***********************************************************************************
*/
#define     ARCMSR_ATU_LATENCY_TIMER_REG		         0x0D    /*byte*/
/*
***********************************************************************************
**  ATU Header Type Register - ATUHTR
**  -----------------------------------------------------------------
**  Bit       Default                       Description
**  07           0 2                        Single Function/Multi-Function Device - Identifies the 80331 as a single-function PCI device.
**  06:00   000000 2                        PCI Header Type - This bit field indicates the type of PCI header implemented. The ATU interface
**                                          header conforms to PCI Local Bus Specification, Revision 2.3.
***********************************************************************************
*/
#define     ARCMSR_ATU_HEADER_TYPE_REG		         0x0E    /*byte*/
/*
***********************************************************************************
**  ATU BIST Register - ATUBISTR
**
**  The ATU BIST Register controls the functions the Intel XScale core performs when BIST is
**  initiated. This register is the interface between the host processor requesting BIST functions and
**  the 80331 replying with the results from the software implementation of the BIST functionality.
**  -----------------------------------------------------------------
**  Bit       Default                       Description
**  07           0 2                        BIST Capable - This bit value is always equal to the ATUCR ATU BIST Interrupt Enable bit. 
**  06           0 2                        Start BIST - When the ATUCR BIST Interrupt Enable bit is set:
**  				 Setting this bit generates an interrupt to the Intel XScale core to perform a software BIST function.
**  				 The Intel XScale core clears this bit when the BIST software has completed with the BIST results
**  				 found in ATUBISTR register bits [3:0].
**  				 When the ATUCR BIST Interrupt Enable bit is clear:
**  				 Setting this bit does not generate an interrupt to the Intel XScale core and no BIST functions is performed. 
**                                                       The Intel XScale core does not clear this bit.
**  05:04       00 2             Reserved
**  03:00     0000 2             BIST Completion Code - when the ATUCR BIST Interrupt Enable bit is set and the ATUBISTR Start BIST bit is set (bit 6):
**                               The Intel XScale  core places the results of the software BIST in these bits. 
**				 A nonzero value indicates a device-specific error.
***********************************************************************************
*/
#define     ARCMSR_ATU_BIST_REG		         0x0F    /*byte*/

/*
***************************************************************************************  
**            ATU Base Registers and Associated Limit Registers
***************************************************************************************
**           Base Address                         Register Limit                          Register Description
**  Inbound ATU Base Address Register 0           Inbound ATU Limit Register 0            Defines the inbound translation window 0 from the PCI bus.
**  Inbound ATU Upper Base Address Register 0     N/A                                     Together with ATU Base Address Register 0 defines the inbound **								translation window 0 from the PCI bus for DACs.
**  Inbound ATU Base Address Register 1           Inbound ATU Limit Register 1            Defines inbound window 1 from the PCI bus.
**  Inbound ATU Upper Base Address Register 1     N/A                                     Together with ATU Base Address Register 1 defines inbound window **  1 from the PCI bus for DACs.
**  Inbound ATU Base Address Register 2           Inbound ATU Limit Register 2            Defines the inbound translation window 2 from the PCI bus.
**  Inbound ATU Upper Base Address Register 2     N/A                                     Together with ATU Base Address Register 2 defines the inbound ** **  translation window 2 from the PCI bus for DACs.
**  Inbound ATU Base Address Register 3           Inbound ATU Limit Register 3            Defines the inbound translation window 3 from the PCI bus.
**  Inbound ATU Upper Base Address Register 3     N/A                                     Together with ATU Base Address Register 3 defines the inbound ** **  translation window 3 from the PCI bus for DACs.
**     NOTE: This is a private BAR that resides outside of the standard PCI configuration header space (offsets 00H-3FH).
**  Expansion ROM Base Address Register           Expansion ROM Limit Register            Defines the window of addresses used by a bus master for reading **  from an Expansion ROM.
**--------------------------------------------------------------------------------------
**  ATU Inbound Window 1 is not a translate window. 
**  The ATU does not claim any PCI accesses that fall within this range. 
**  This window is used to allocate host memory for use by Private Devices. 
**  When enabled, the ATU interrupts the Intel  XScale core when either the IABAR1 register or the IAUBAR1 register is written from the PCI bus. 
***********************************************************************************
*/

/*
***********************************************************************************
**  Inbound ATU Base Address Register 0 - IABAR0
**
**  . The Inbound ATU Base Address Register 0 (IABAR0) together with the Inbound ATU Upper Base Address Register 0 (IAUBAR0) 
**    defines the block of memory addresses where the inbound translation window 0 begins. 
**  . The inbound ATU decodes and forwards the bus request to the 80331 internal bus with a translated address to map into 80331 local memory. 
**  . The IABAR0 and IAUBAR0 define the base address and describes the required memory block size.
**  . Bits 31 through 12 of the IABAR0 is either read/write bits or read only with a value of 0 
**    depending on the value located within the IALR0. 
**    This configuration allows the IABAR0 to be programmed per PCI Local Bus Specification.
**    The first 4 Kbytes of memory defined by the IABAR0, IAUBAR0 and the IALR0 is reserved for the Messaging Unit.
**    The programmed value within the base address register must comply with the PCI programming requirements for address alignment. 
**  Warning: 
**    When IALR0 is cleared prior to host configuration:
**                          the user should also clear the Prefetchable Indicator and the Type Indicator. 
**    Assuming IALR0 is not cleared:
**                          a. Since non prefetchable memory windows can never be placed above the 4 Gbyte address boundary,
**                             when the Prefetchable Indicator is cleared prior to host configuration, 
**                             the user should also set the Type Indicator for 32 bit addressability.
**                          b. For compliance to the PCI-X Addendum to the PCI Local Bus Specification,
**                             when the Prefetchable Indicator is set prior to host configuration, the user
**                             should also set the Type Indicator for 64 bit addressability. 
**                             This is the default for IABAR0.
**  -----------------------------------------------------------------
**  Bit       Default                       Description
**  31:12     00000H                        Translation Base Address 0 - These bits define the actual location 
**						the translation function is to respond to when addressed from the PCI bus.
**  11:04        00H                        Reserved.
**  03           1 2                        Prefetchable Indicator - When set, defines the memory space as prefetchable.
**  02:01       10 2                        Type Indicator - Defines the width of the addressability for this memory window:
**  						00 - Memory Window is locatable anywhere in 32 bit address space
**  						10 - Memory Window is locatable anywhere in 64 bit address space
**  00           0 2                        Memory Space Indicator - This bit field describes memory or I/O space base address. 
**                                                                   The ATU does not occupy I/O space, 
**                                                                   thus this bit must be zero.
***********************************************************************************
*/
#define     ARCMSR_INBOUND_ATU_BASE_ADDRESS0_REG		         0x10    /*dword 0x13,0x12,0x11,0x10*/
#define     ARCMSR_INBOUND_ATU_MEMORY_PREFETCHABLE	                 0x08
#define     ARCMSR_INBOUND_ATU_MEMORY_WINDOW64		                 0x04
/*
***********************************************************************************
**  Inbound ATU Upper Base Address Register 0 - IAUBAR0
**
**  This register contains the upper base address when decoding PCI addresses beyond 4 GBytes.
**  Together with the Translation Base Address this register defines the actual location the translation
**  function is to respond to when addressed from the PCI bus for addresses > 4GBytes (for DACs).
**  The programmed value within the base address register must comply with the PCI programming requirements for address alignment. 
**  Note: 
**      When the Type indicator of IABAR0 is set to indicate 32 bit addressability, 
**      the IAUBAR0 register attributes are read-only.
**  -----------------------------------------------------------------
**  Bit       Default                       Description
**  31:0      00000H                        Translation Upper Base Address 0 - Together with the Translation Base Address 0 these bits define the
**                           actual location the translation function is to respond to when addressed from the PCI bus for addresses > 4GBytes.
***********************************************************************************
*/
#define     ARCMSR_INBOUND_ATU_UPPER_BASE_ADDRESS0_REG		     0x14    /*dword 0x17,0x16,0x15,0x14*/
/*
***********************************************************************************
**  Inbound ATU Base Address Register 1 - IABAR1
**
**  . The Inbound ATU Base Address Register (IABAR1) together with the Inbound ATU Upper Base Address Register 1 (IAUBAR1) 
**    defines the block of memory addresses where the inbound translation window 1 begins. 
**  . This window is used merely to allocate memory on the PCI bus and, the ATU does not process any PCI bus transactions to this memory range.
**  . The programmed value within the base address register must comply with the PCI programming requirements for address alignment. 
**  . When enabled, the ATU interrupts the Intel XScale core when the IABAR1 register is written from the PCI bus. 
**    Warning: 
**    When a non-zero value is not written to IALR1 prior to host configuration, 
**                          the user should not set either the Prefetchable Indicator or the Type Indicator for 64 bit addressability. 
**                          This is the default for IABAR1.
**    Assuming a non-zero value is written to IALR1, 
**               			the user may set the Prefetchable Indicator 
**               			              or the Type         Indicator:
**  						a. Since non prefetchable memory windows can never be placed above the 4 Gbyte address
**  						   boundary, when the Prefetchable Indicator is not set prior to host configuration, 
**                             the user should also leave the Type Indicator set for 32 bit addressability. 
**                             This is the default for IABAR1.
**  						b. when the Prefetchable Indicator is set prior to host configuration, 
**                             the user should also set the Type Indicator for 64 bit addressability.
**  -----------------------------------------------------------------
**  Bit       Default                       Description
**  31:12     00000H                        Translation Base Address 1 - These bits define the actual location of window 1 on the PCI bus.
**  11:04        00H                        Reserved.
**  03           0 2                        Prefetchable Indicator - When set, defines the memory space as prefetchable.
**  02:01       00 2                        Type Indicator - Defines the width of the addressability for this memory window:
**  			00 - Memory Window is locatable anywhere in 32 bit address space
**  			10 - Memory Window is locatable anywhere in 64 bit address space
**  00           0 2                        Memory Space Indicator - This bit field describes memory or I/O space base address. 
**                                                                   The ATU does not occupy I/O space, 
**                                                                   thus this bit must be zero.
***********************************************************************************
*
